/***************************************************************\
*	cqlib.c							*
*	Library file for CQ analysis				*
*	08nov90 dpwe						*
\***************************************************************/

#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include <string.h>

#include "cqlib.h"

#include <gendsp.h>
#include <window.h>

#include "ds_fir_93.h"	/* special filter coeffs */

int lf_cut;
int dc_out;

static float *dumstor = NULL;

void DSby2for80pc(src,len,dst)	/* dedicated ds-by-2 */
    /* designed by matlab remez for 1db ripple to .4xFs, 40dB stop */
    float	*src;
    long	len;
    float	*dst;
    {
    long 	cnt;
    float 	*sce, *rslt;

    abort();
    Convo(src, 1, len, ds_fir, 1, DS_FIR_LEN);
    cnt = len/2;
    sce = src;
    rslt = dst;
    while(cnt--)
	{
	*rslt++ = *sce;
	sce += 2;
	}
    return;
    }

void DownSampleBy2(src,len,dst)	/* dedicated downsample-by-2 filter */
    float	*src;		/* orig signal */
    long	len;		/* pts in orig signal */
    float	*dst;		/* result signal - len/2 pts */
    {		/* as a sp case, dst may be 1st half of sig (src=dst) */
    float	*sce,*rslt;
    float	a0,a1,a2,a3,a4;
    float	tmp[8];
    long	i;
    long	cnt;
#define LOBES 16			/* sidelobes for sinc */
    float	newkern[LOBES*4 + 1];
    long	nklen = LOBES*4 + 1;
    WINDAT	*w;
    float	sign = 1;

    a0 = lf_cut?.5:1.0/sqrt(2.0);
    /* setup newkern */
    newkern[LOBES*2] = a0;
    for(i = 0; i<LOBES; ++i)
	{
	newkern[LOBES*2 + 2*i + 2] = newkern[LOBES*2 - 2*i - 2] = 0;
	newkern[LOBES*2+2*i+1] = newkern[LOBES*2-2*i-1] = 
	    a0*sign*(.54+.46*cos(PI*(2*i+1)/(2*LOBES)))*2/(2*i+1)/PI;
	sign = -sign;
	}
/*    w = NewWin("us kern",1);
    DoDisp(w, newkern, nklen);	*/

    /* first filter out any supra-nyquist frequencies */
    abort();
    Convo(src, 1, len, newkern, 1, nklen);
    /* then just decimate safely */
    cnt = len/2;
    sce = src;
    rslt = dst;
    while(cnt--)
	{
	*rslt++ = *sce;
	sce += 2;
	}
    return;


    /* coefs hand calculated for 1/2(1+cos(w/8))*sin(w)/w, w = 0 to 8 pi */
    a1 = .612390;  a2 = -.187311; a3 = .039300;  a4 = -.003461;
    sce = src; rslt = dst;

    tmp[0] = a0*(sce[0] + a1*sce[1] + a2*sce[3] + a3*sce[5] + a4*sce[7]);
    sce += 2;
    tmp[1] = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*sce[3] 
		 + a3*sce[5] + a4*sce[7]);
    sce += 2;
    tmp[2] = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3])
		 + a3*sce[5] + a4*sce[7]);
    sce += 2;
    tmp[3] = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*sce[7]);
    sce += 2;
    /* we're out of the woods now - no underlap */
    tmp[4] = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*(sce[7]+sce[-7]));
    sce += 2;
    tmp[5] = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*(sce[7]+sce[-7]));
    sce += 2;
    tmp[6] = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*(sce[7]+sce[-7]));
    sce += 2;
    tmp[7] = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*(sce[7]+sce[-7]));
    sce += 2;
    /* sce last referred to src+14-7 = src+7, next src+9 */
    /* guaranteed to stay ahead of in-place replacement now! */
    /* write back the temps... */
    for(i = 0; i<7; ++i)
	*rslt++ = tmp[i];
    /* fixup the counter.. */
    cnt = (len/2) - 7 - 4;	/* number of points still to calculate */
    while(cnt--)
	{
	*rslt++ = a0* (*sce + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3])
	               + a3*(sce[5]+sce[-5])  + a4*(sce[7]+sce[-7]));
	sce += 2;
	}
    /* last few points are special case.. */
    *rslt++ = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*sce[-7]);
    sce += 2;
    *rslt++ = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*sce[-5] + a4*sce[-7]);
    sce += 2;
    *rslt++ = a0*(sce[0] + a1*(sce[1]+sce[-1]) + a2*sce[-3] 
		 + a3*sce[-5] + a4*sce[-7]);
    sce += 2;
    *rslt++ = a0*(sce[0] + a1*sce[-1] + a2*sce[-3] 
		 + a3*sce[-5] + a4*sce[-7]);
    sce += 2;

    }

void UpSampleBy2(src,len,dst)	/* upsamples & filters a signal by 2x */
    float	*src;		/* original sequence */
    long	len;		/* points in original sequence */
    float	*dst;		/* result buffer 2x len */
    {		/* as special case, sce may overlay 1st half of dst */
    float	*sce,*rslt;
    float	a0,a1,a2,a3,a4;
    long	i;
    long	cnt;
#define LOBES 16			/* sidelobes for sinc */
    float	newkern[LOBES*4 + 1];
    long	nklen = LOBES*4 + 1;
    WINDAT	*w;
    float	sign = 1;

    a0 = lf_cut?1.0/(sqrt(2.0)):1.0;
    /* setup newkern */
    newkern[LOBES*2] = a0;
    for(i = 0; i<LOBES; ++i)
	{
	newkern[LOBES*2 + 2*i + 2] = newkern[LOBES*2 - 2*i - 2] = 0;
	newkern[LOBES*2+2*i+1] = newkern[LOBES*2-2*i-1] = 
	    a0*sign*(.54+.46*cos(PI*(2*i+1)/(2*LOBES)))*2/(2*i+1)/PI;
	sign = -sign;
	}
/*    w = NewWin("us kern",1);
    DoDisp(w, newkern, nklen);	*/

    /* coefs hand calculated for 1/2(1+cos(w/4))*sin(w)/w, w= 1,3,5,7 * pi/2 */
    a1 = .612390;  a2 = -.187311;  a3 = .039300;  a4 = -.003461;

    /* first off, interpolate with zeros */
    /* copy backwards to allow overlap */
    sce = src+len-1; rslt = dst+2*len-/* 2 */ 1; 
    cnt = len;
    if(cnt)
	do  {
	/*    *rslt = a0* *sce--;
	    rslt -= 2;	*/
	    *rslt-- = 0;
	    *rslt-- = a0* *sce--;
	    } while(--cnt);
    
    abort();
    Convo(dst, 1, 2*len, newkern, 1, nklen);
    return;

    /* then fill in alternate values with interpolation */
    sce = dst;
    cnt = len;
    /* first few values are special cases .. */
    ++sce;  

/*    *sce = a1*sce[1] + a2*sce[3] + a3*sce[5] + a4*sce[7];
    sce += 2; */
    *sce = a1*(sce[-1]+sce[1]) + a2*sce[3] + a3*sce[5] + a4*sce[7];
    sce += 2;
    *sce = a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3])
		 + a3*sce[5] + a4*sce[7];
    sce += 2;
    *sce = a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*sce[7];
    sce += 2;
    cnt -= 3 + 4;	/* number of points still to calculate */
    while(cnt--)
	{
	*sce = a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3])
	               + a3*(sce[5]+sce[-5])  + a4*(sce[7]+sce[-7]);
	sce += 2;
	}
    /* last few points are special case.. */
    *sce = a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*(sce[5]+sce[-5]) + a4*sce[-7];
    sce += 2;
    *sce = a1*(sce[1]+sce[-1]) + a2*(sce[3]+sce[-3]) 
		 + a3*sce[-5] + a4*sce[-7];
    sce += 2;
    *sce = a1*(sce[1]+sce[-1]) + a2*sce[-3] 
		 + a3*sce[-5] + a4*sce[-7];
    sce += 2;
    *sce = a1*sce[-1] + a2*sce[-3] 
		 + a3*sce[-5] + a4*sce[-7];
    sce += 2;	/* last pt has been copied */
    }

void oldAppKernels(signal,sLen,kerns,kLen,nBins,hopSize,frameSize,dilate,rslt)
    float	*signal;	/* input time vector */
    long	sLen;		/* length of above */
    float	*kerns;		/* kernel table.. */
    long	kLen;		/* length of each kernel */
    int 	nBins;		/* number of kernels in each 1/2 (sin/cos) */
    long	hopSize;	/* increment along signal */
    long	frameSize;	/* increment along rslt (for timehops) */
    int 	dilate;		/* how much to upsample output points */
    float	*rslt;		/* put results here */
    {
    int 	i,j;
    float	u,v,m,p;
    long	sIndx = 0;
    float	*sPtr, *kPtr;
    long	ipLen, ovLap;
    long	kOffset;
    float	*thisRslt, *thisKern;
    float	InnerProd();

    if(hopSize == 0)
	{  fprintf(stderr,"AppKs: ran out of hops (use lower -o)\n");
	   exit(1); }
    kOffset = (kLen-1)/2;
    thisRslt = rslt;	/* start at low frequency */
    thisKern = kerns;
    while(sIndx < sLen)		/* outer loop is time frames */
	{
	for(i=0; i<nBins; ++i)	/* inner loop is freq. kernels */
	    {
	    sPtr = signal + sIndx - kOffset;
	    kPtr = kerns + kLen * 2 * i;
	    ipLen = kLen;
	    if( (ovLap = kOffset - sIndx) > 0)	/* more offset than data */
		{
		sPtr += ovLap;	/* == signal, first value */
		kPtr += ovLap;	/* lop off start of kernel */
		ipLen -= ovLap;	/* compute smaller inner product */
		}
	    if( (ovLap = sIndx + kLen - kOffset - sLen) > 0)
		ipLen -= ovLap;	/* clip at end too */
	    u = InnerProd(sPtr,1,kPtr,1,(long)ipLen);		/* cos.. */
	    v = InnerProd(sPtr,1,kPtr+kLen,1,(long)ipLen);  	/* + sin */
	    m = hypot(v,u);
	    if(m == 0.0)	p = 0.0;
	    else		p = atan2(v,u);
/*	    if( ((sIndx&1023) == 0) && (i == 10))
		fprintf(stderr,"a %f b%f mag %f pha %f\n",u,v,m,p);	*/
 	    for(j=0; j<dilate; ++j)
		{ *thisRslt++ = m;  *(thisRslt++) = p;  }      /* replicate */
	    }
	sIndx += hopSize;	/* next time origin.. */
	thisRslt += 2*(frameSize - (dilate * nBins));	/* next result frame */
	}
    }

void ApplyKernels(signal,sLen,kerns,kLen,nBins,hopSize,frameSize,dilate,rslt)
    float	*signal;	/* input time vector */
    long	sLen;		/* length of above */
    float	*kerns;		/* kernel table.. */
    long	kLen;		/* length of each kernel */
    int 	nBins;		/* number of kernels in each 1/2 (sin/cos) */
    long	hopSize;	/* increment along signal */
    long	frameSize;	/* increment along rslt (for timehops) */
    int 	dilate;		/* how much to upsample output points */
    float	*rslt;		/* put results here */
    {
    int 	i,j;
    float	u,v,m,p;
    long	sIndx = 0;
    long	sStart, sEnd;
    float	*sPtr, *kPtr;
    long	ipLen, ovLap;
    long	kOffset,kPffset;
    float	*thisRslt, *thisKern;
    float	InnerProd();

    if(hopSize == 0)
	{  fprintf(stderr,"AppKs: ran out of hops (use lower -o)\n");
	   exit(1); }
    if(dilate != 1)
	{  fprintf(stderr,"AppKs: Dilate must be 1, not %d\n", dilate);
	   exit(1); }	/* feature withdrawn */
    kOffset = kLen/2;		/* was (kLen-1)/2 : can't decide */
    kPffset = kLen - kOffset;	/* .. so they add to kLen */
    thisKern = kerns;
    while(sIndx < sLen)		/* outer loop is time frames */
	{
	if(sIndx < kOffset)
	    sStart = -sIndx;
	else
	    sStart = -kOffset;	/* don't underlap the buffer */
	if( (sIndx+kPffset) > sLen )
	    sEnd = sLen - sIndx;
	else
	    sEnd = kPffset;
	ApplyKernBlock(signal+sIndx, sStart, sEnd, kerns, kLen, 2*nBins, rslt);
	Rect2Polar(rslt, nBins);
	sIndx += hopSize;	/* next time origin.. */
	rslt += 2*frameSize;	/* next result frame */
	}
    }

void ApplyKernBlock(sig, sStart, sEnd, kerns, kLen, nKerns, rslt)
    /* usage: AKB(sig, -len/2, len/2, ... applies the kernel to len
                                      points from sig-len/2 to sig+len/2-1 incl
	      AKB(sig, 0, len/2, ..   is centered the same as above, but
	                              does not try to access pts before sig */
    /* calculate transform of one time frame against array of kernels */
    float	*sig;	/* 'center' of signal block */
    long	sStart;	/* first element to be accessed ( typ <0 )*/
    long	sEnd;	/* last element to be accessed */
    float	*kerns;
    long	kLen;
    int 	nKerns;	/* array of kernels to apply */
    float	*rslt;	/* where to leave answers */
    {
    int 	i;
    long	ipLen, ovLap, kOffset;
    float	*kPtr,*sPtr;

    kOffset = kLen/2;
    ipLen = kLen;
    kPtr  = kerns;
    sPtr  = sig - kOffset;
    if( (ovLap = kOffset + sStart) > 0) /* more offset than data */
	{
	sPtr += ovLap;		/* == signal, first value */
	kPtr += ovLap;		/* lop off start of kernel */
	ipLen -= ovLap;		/* compute smaller inner product */
	}
    if( (ovLap =  (kLen - kOffset) - sEnd) > 0)
	ipLen -= ovLap;		/* clip at end too */
    for(i = 0; i<nKerns; ++i)
	{
	*rslt++ = InnerProd(sPtr,1,kPtr,1,(long)ipLen);
	kPtr += kLen;		/* point to next kernel start */
	}
    }

void ExpandCoefBlock(sig, sStart, sEnd, kerns, kLen, nKerns, coefs)
    /* this function scales an array of kernels with a vector of
       coefficients and overlays the results into a buffer */
    /* usage: AKB(sig, -len/2, len/2, ... applies the kernel to len
                                      points from sig-len/2 to sig+len/2-1 incl
	      AKB(sig, 0, len/2, ..   is centered the same as above, but
	                              does not try to access pts before sig */
    /* calculate transform of one time frame against array of kernels */
    float	*sig;	/* 'center' of output signal block */
    long	sStart;	/* first element to be written ( typ < 0 ) */
    long	sEnd;	/* last element to be written */
    float	*kerns;
    long	kLen;
    int 	nKerns;	/* array of kernels to apply */
    float	*coefs;	/* vector of coefs for the kernels */
    {
    int 	i;
    long	ipLen, ovLap, kOffset;
    float	*kPtr,*sPtr;

    kOffset = kLen/2;
    ipLen = kLen;
    kPtr  = kerns;
    sPtr  = sig - kOffset;
    if( (ovLap = kOffset + sStart) > 0) /* kernels exceed output vec size */
	{
	sPtr += ovLap;		/* == signal, first value */
	kPtr += ovLap;		/* lop off start of kernel */
	ipLen -= ovLap;		/* overlay fewer points */
	}
    if( (ovLap =  (kLen - kOffset) - sEnd) > 0)
	ipLen -= ovLap;		/* clip at end too */
    for(i = 0; i<nKerns; ++i)
	{
	Overlay(kPtr, 1, sPtr, 1, (long)ipLen, *coefs++); /* overlay kernel */
	kPtr += kLen;		/* point to next kernel start */
	}
    }

void SetupRKernels(nBins,qFactor,botFrq,kernLen,kernels,gain)
    int 	nBins;		/* number of divisions of an octave */
    FLOATARG	qFactor;	/* frq/bandwidth factor */
    FLOATARG	botFrq;		/* frequency of lowest (rad/step) */
    long	kernLen;	/* length of each entry */
    float	*kernels;	/* where to put results */
    FLOATARG	gain;
    {
    int 	i;
    long        j;
    float	dc,sc,t,s,c,w,omega,wconst,frqFctr,weight,wFctr;
    float	*costab, *sintab;
    long	halfKlen;

    halfKlen = kernLen/2;
    wconst   = log(2.0)/(qFactor*qFactor*PI/2/botFrq);
    omega    = botFrq;
    frqFctr  = exp(log(2.0)/(float)nBins);
    wFctr    = exp(.5*log(2.0)/(float)nBins);	/* scale amps for const E */
    weight   = gain;			/* altered to keep integral-dt const */
    costab = kernels;			/* output is the cos's.. */
    sintab = costab + kernLen;		/* .. and the sin's interleaved, NOT */
/*    costab = kernels;			/* output is all the cos's.. */
/*    sintab = costab + nBins*kernLen;	/* .. then all the sin's */
    printf("bins %d Q %f frq %f kLen %d const %f fctr %f\n",
	   nBins, qFactor, botFrq, kernLen, wconst, frqFctr);
    for(i=0; i<nBins; ++i)
	{
	for(j=0; j<=halfKlen; ++j)
	    {
	    w = weight * exp(-omega*omega*wconst*(float)j*j);
	    t = .5*(1 + cos((float)j/(float)halfKlen));
	    c = w * t * cos(omega*(float)j);
	    s = w * t * sin(omega*(float)j);
	    costab[halfKlen+j] = c;
	    costab[halfKlen-j] = c;
	    sintab[halfKlen+j] = s;
	    sintab[halfKlen-j] = -s;
	    if(j==0)
		dc = -c;
	    dc += 2*c;
	    }
	dc = dc/(.54 * (float)(2*halfKlen+1));
	if(dc_out)
	    {
	    costab[halfKlen] -= dc;
	    for(j=1; j<=halfKlen; ++j)
		{
		costab[halfKlen+j] -= sc 
		    = dc * (.5 + .5 * cos((float)j/((float)halfKlen)));
		costab[halfKlen-j] -= sc;
		}
	    }
	weight *= wFctr;	
	if(lf_cut)
	    weight *= wFctr;	
	else
	    weight /= wFctr;
	omega  *= frqFctr;
	costab += 2*kernLen;
	sintab += 2*kernLen;
/*	costab += kernLen;	*/
/*	sintab += kernLen;	*/
	}
    }

void SetupKernels(nBins,qFactor,botFrq,kernLen,kernels)
    int 	nBins;		/* number of divisions of an octave */
    double	qFactor;	/* frq/bandwidth factor */
    double	botFrq;		/* frequency of lowest (rad/step) */
    long	kernLen;	/* length of each entry */
    float	*kernels;	/* where to put results */
    {
    int 	i;
    long	j;
    float	s,c,t,w,omega,wconst,frqFctr,weight,wFctr;
    float	*costab, *sintab;
    long	halfKlen;
    float	dc = 0.0, sc;

    halfKlen = kernLen/2;
    wconst   = log(2.0)/(qFactor*qFactor*PI/2/botFrq);
    omega    = botFrq;
    frqFctr  = exp(log(2.0)/(float)nBins);
    wFctr    = exp(.5*log(2.0)/(float)nBins);
    weight   = 1;			/* to keep integral-dt const */
    costab = kernels;			/* output is the cos's.. */
    sintab = costab + kernLen;		/* .. and the sin's interleaved, NOT */
/*    costab = kernels;			/* output is all the cos's.. */
/*    sintab = costab + nBins*kernLen;	/* .. then all the sin's */
    printf("bins %d Q %f frq %f kLen %d const %f fctr %f\n",
	   nBins, qFactor, botFrq, kernLen, wconst, frqFctr);
    for(i=0; i<nBins; ++i)
	{
	for(j=0; j<=halfKlen; ++j)
	    {
	    w = weight * exp(-omega*omega*wconst*(float)j*j);
	    t = .5*(1 + cos((float)j/(float)halfKlen));
	    c = w * t * cos(omega*(float)j);
	    s = w * t * sin(omega*(float)j);
	    costab[halfKlen+j] = c;
	    costab[halfKlen-j] = c;
	    sintab[halfKlen+j] = s;
	    sintab[halfKlen-j] = -s;
	    if(j==0)
		dc = -c;
	    dc += 2*c;
	    }
	dc = dc/(.54 * (float)(2*halfKlen+1));
	if(dc_out)
	    {
	    costab[halfKlen] -= dc;
	    for(j=1; j<=halfKlen; ++j)
		{
		costab[halfKlen+j] -= sc 
		    = dc * (.5 + .5 * cos((float)j/((float)halfKlen)));
		costab[halfKlen-j] -= sc;
		}
	    }
	weight *= wFctr;
	if(lf_cut)		/* extra weight for HF if LF cut */
	    weight *= wFctr;
	omega  *= frqFctr;
	costab += 2*kernLen;	/* interleaved sin & cos */
	sintab += 2*kernLen;	/* .. means successive cos's 2xLen apart */
/*	costab += kernLen;	*/	/* NOT all cos's then all sin's */
/*	sintab += kernLen;	*/
	}
    }

void NewSetupKernels(nBins,qFactor,botFrq,kernLen,kernels,sign,gain)
    int 	nBins;		/* number of divisions of an octave */
    double	qFactor;	/* frq/bandwidth factor */
    double	botFrq;		/* frequency of lowest (rad/step) */
    long	kernLen;	/* length of each entry */
    float	*kernels;	/* where to put results */
    int 	sign;		/* +1 for fwd, -1 for rvs */
    FLOATARG	gain;		/* overall scaling applied to kernel */
    {
    int 	i;
    long	j;
    float	s,c,t,w,omega,wconst,frqFctr,weight,wFctr;
    float	*costab, *sintab;
    long	halfKlen;
    float	dc = 0.0, sc;

    /* If kerns are 2n long, we can only use central point (k[n-1]) 
       and n-1 on each side (k[0..2n-2])  */
    halfKlen = (kernLen-1)/2;
    wconst   = log(2.0)/(qFactor*qFactor*PI/2/botFrq);
    omega    = botFrq;
    frqFctr  = exp(log(2.0)/(float)nBins);
    wFctr    = exp(.5*log(2.0)/(float)nBins);	/* bigger than one */
    weight   = gain /* 1 */;			/* to keep integral-dt const */
    costab = kernels;			/* output is the cos's.. */
    sintab = costab + kernLen;		/* .. and the sin's interleaved, NOT */
    printf("bins %d Q %f frq %f kLen %d const %f fctr %f\n",
	   nBins, qFactor, botFrq, kernLen, wconst, frqFctr);
    for(i=0; i<nBins; ++i)	/* start at low frequency */
	{
	if( (kernLen % 2) == 0)	/* even length kernels not all filled */
	    costab[kernLen-1] = sintab[kernLen-1] = 0.0;
	for(j=0; j<=halfKlen; ++j)
	    {
	    w = weight * exp(-omega*omega*wconst*(float)j*j);
	    t = .5*(1 + cos((float)j/(float)halfKlen));
	    c = w * t * cos(omega*(float)j);
	    s = w * t * sin(omega*(float)j)*(float)sign;
	    costab[halfKlen+j] = costab[halfKlen-j] = c;
	    sintab[halfKlen+j] = -(sintab[halfKlen-j] = s);
	    if(j==0)	dc = -c;
	    dc += 2*c;
	    }
	dc = dc/(.54 * (float)(2*halfKlen+1));
	if(dc_out)
	    {
	    costab[halfKlen] -= dc;
	    for(j=1; j<=halfKlen; ++j)
		{
		costab[halfKlen+j] -= sc 
		    = dc * (.5 + .5 * cos((float)j/((float)halfKlen)));
		costab[halfKlen-j] -= sc;
		}
	    }
/*	weight *= wFctr;	*/
	weight *= wFctr*wFctr;
	omega  *= frqFctr;
	costab += 2*kernLen;	/* interleaved sin & cos */
	sintab += 2*kernLen;	/* .. means successive cos's 2xLen apart */
	}
    }

void UndoKernels(signal,sLen,kerns,kLen,nBins,hopSize,frameSize,
		 dilate,rslt)
    float	*signal;	/* result time vector - superpose */
    long	sLen;		/* length of above */
    float	*kerns;		/* kernel table.. */
    long	kLen;		/* length of each kernel */
    int 	nBins;		/* number of kernels in each 1/2 (sin/cos) */
    long	hopSize;	/* increment along signal */
    long	frameSize;	/* increment along rslt (for timehops) */
    int 	dilate;		/* how much to upsample output points */
    float	*rslt;		/* initial coefs here */
    {
    int 	i;
    float	u,v,m,p;
    long	sIndx = 0;
    float	*sPtr, *kPtr;
    long	ipLen, ovLap;
    long	kOffset;
    float	*thisRslt;
    float	InnerProd();

    static 	int	invok = 2;

    ++invok;

    kOffset = (kLen-1)/2;
    thisRslt = rslt;		/* start at low frequency */
    while(sIndx < sLen)		/* outer loop is time frames */
	{
	for(i=0; i<nBins; ++i)	/* inner loop is freq. kernels */
	    {
	    m = *thisRslt++;	p = *thisRslt++;
	    thisRslt += (dilate-1)*2; /* skip dilated values */

/*	    if(i == invok && sIndx == hopSize * 10 * invok)
		m = 1000;
	    else 
		m = 0;	*/
	    u = m * cos(p);	v = m * sin(p);
	    sPtr = signal + sIndx - kOffset;
	    kPtr = kerns + kLen * 2 * i;	/* kernels in pairs */
	    ipLen = kLen;
	    if( (ovLap = kOffset - sIndx) > 0) /* more offset than sound */
		{
		sPtr += ovLap;	/* == signal, first value */
		kPtr += ovLap;	/* lop off start of kernel */
		ipLen -= ovLap; /* overlay fewer pts of kernel */
		}
	    if( (ovLap = sIndx + kLen - kOffset - sLen) > 0)
		ipLen -= ovLap; /* clip at end too */
	    Overlay(kPtr, 1, sPtr, 1, (long)ipLen, u); /* write cos */
	    Overlay(kPtr+kLen,1,sPtr,1,(long)ipLen, v); /* & sine */

	    /*	    if( ((sIndx&1023) == 0) && (i == 10))
		    printf("a %f b%f mag %f pha %f\n",u,v,m,p);	*/
	    }
	sIndx += hopSize;	/* next time origin.. */
	thisRslt += 2*(frameSize - (dilate * nBins)); /* next coef frame */
	}
    }
