/***************************************************************\
*	cqlib.h							*
*	Library file for CQ analysis				*
*	08nov90 dpwe						*
\***************************************************************/

#include <sndfutil.h>		/* provides ConvertSoundFormat() */

#ifndef PI
#define PI M_PI
#endif /* PI */
#define MAXKLEN		4096	/* longest kern len - for dumstor */
#define MAXOCTS		20	/* most octaves possible */

extern int lf_cut;
extern int dc_out;

extern float *dumstor;

#ifdef __STDC__

void DSby2for80pc(float *src, long len, float *dst);
    /* /2 ds designed by matlab remez for 1db ripple to .4xFs, 40dB stop */
void DownSampleBy2(float *src, long len, float *dst);
    /* dedicated downsample-by-2 filter */
void UpSampleBy2(float *src, long len, float *dst);
    /* upsamples & filters a signal by 2x */
void oldAppKernels(float *signal,long sLen,float *kerns, long kLen, int nBins, 
		  long hopSize, long frameSize, int dilate, float *rslt);
void ApplyKernels(float *signal,long sLen, float *kerns, long kLen, int nBins, 
		  long hopSize, long frameSize, int dilate, float *rslt);
void ApplyKernBlock(float *sig, long sStart, long sEnd, 
		    float *kerns, long kLen, int nKerns, float *rslt);
    /* usage: AKB(sig, -len/2, len/2, ... applies the kernel to len
                                      points from sig-len/2 to sig+len/2-1 incl
	      AKB(sig, 0, len/2, ..   is centered the same as above, but
	                              does not try to access pts before sig */
    /* calculate transform of one time frame against array of kernels */
void ExpandCoefBlock(float *sig, long sStart, long sEnd, 
		     float *kerns, long kLen, int nKerns, float *coefs);
    /* this function scales an array of kernels with a vector of
       coefficients and overlays the results into a buffer */
void SetupRKernels(int nBins, FLOATARG qFactor, FLOATARG botFrq,
		   long kernLen, float *kernels, FLOATARG gain);
void SetupKernels(int nBins, FLOATARG qFactor, FLOATARG botFrq,
		   long kernLen, float *kernels);
void NewSetupKernels(int nBins, FLOATARG qFactor, FLOATARG botFrq, 
		     long kernLen, float *kernels, int sign, FLOATARG gain);
void UndoKernels(float *signal, long sLen,float *kerns, long kLen, int nBins, 
	 long hopSize, long frameSize, int dilate, float *rslt);

#else
void DownSampleBy2();
void UpSampleBy2();
void oldApplyKernels();
void ApplyKernels();
void ApplyKernBlock();
void ExpandCoefBlock();
void SetupRKernels();
void SetupKernels();
void NewSetupKernels();
void UndoKernels();

#endif
