/*******************************************************************\
*																	*
*	db.evnt.c														*
*																	*	
*	Event loop support functions for DSPbench						*
*																	*
*	29mar90	dpwe													*
*																	*
\*******************************************************************/

#include "DSPbench.h"

extern	MenuHandle	*myMenus;

int	DefWdwID(wtype)
	int 	wtype;
	{
	switch(wtype)
		{
		case TGraphWin:
			return(TGwindowID);
		case TEWin:
			return(TEwindowID);
		default:
			return(TEwindowID);
		}
	}

Idle(wrcd)				/* Idle the front window during event update */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TEIdle((*frntWin)->w.te.TEH);
			break;
		default:
			break;
		}
	}

DoKeyDown(wrcd,key)		/* deal with key down in a given window */
	WINRCD		**wrcd;
	char		key;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TEKey( key, (*frntWin)->w.te.TEH );
			ShowSelect(frntWin);
			(*frntWin)->dirty = 1;
			break;
		default:
			break;
		}
	}

ActivateWin(wrcd)		/* Activate of nominated window */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TEActivate( (*wrcd)->w.te.TEH );
/*			ShowControl( (*wrcd)->w.te.vScroll );
			DisableItem( myMenus[editM], undoCommand );
			TEFromScrap();
 */
			break;
		default:
			break;
		}
	}

DeactivateWin(wrcd)		/* De-activate of nominated window */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TEDeactivate( (*wrcd)->w.te.TEH);
			HideControl( (*wrcd)->w.te.vScroll );
			ZeroScrap();
			TEToScrap();
			break;
		default:
			break;
		}
	}

CutInWin(wrcd)		/* Edit-cut command */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TECut( (*frntWin)->w.te.TEH );
			ShowSelect(frntWin);
			(*frntWin)->dirty = 1;
			break;
		default:
			break;
		}
	}

CopyInWin(wrcd)		/* Edit-copy command */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TECopy( (*frntWin)->w.te.TEH );
			ShowSelect(frntWin);
			break;
		default:
			break;
		}
	}

PasteInWin(wrcd)		/* Edit-Paste command */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TEPaste( (*frntWin)->w.te.TEH );
			(*frntWin)->dirty = 1;
			ShowSelect(frntWin);
			break;
		case TGraphWin:	/* actually zoom */
			break;
		default:
			break;
		}
	}

UndoInWin(wrcd)		/* clover-Z command */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			break;
		case TGraphWin:	/* actually zoom */
			((*wrcd)->w.snd.view)->bStart = ((*wrcd)->w.snd.slct)->bStart;
			((*wrcd)->w.snd.view)->bEnd   = ((*wrcd)->w.snd.slct)->bEnd;
			RedrawWinBit(wrcd,Lvsbarid);
			RedrawWinBit(wrcd,Sviewid);
			RedrawWinBit(wrcd,Infboxid);
			break;
		default:
			break;
		}
	}

ClearInWin(wrcd)		/* Edit-Clear command */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TEDelete( (*frntWin)->w.te.TEH );
			(*frntWin)->dirty = 1;
			ShowSelect(frntWin);
			break;
		default:
			break;
		}
	}

UpdateWin(wrcd)		/* From UpdateWindow() command */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			TEUpdate( &((*wrcd)->myWindow)->portRect, (*wrcd)->w.te.TEH );	
			break;
		case TGraphWin:
			TGupdate(wrcd, NULL);
			break;
		default:
			break;
		}
	}

ClickInWin(wrcd,theEvent)		/* From UpdateWindow() command */
	WINRCD		**wrcd;
	EventRecord	*theEvent;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			ClickInTE(wrcd, theEvent);
			break;
		case TGraphWin:
			ClickInTG(wrcd, theEvent);
			break;
		default:
			break;
		}
	}

GrowWin(wrcd,p)		/* From MyGrowWindow */
	WINRCD		**wrcd;
	Point p;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			GrowTEwin(wrcd, p);
			break;
		case TGraphWin:
			GrowTGwin(wrcd, p);
			break;
		default:
			break;
		}
	}


CloseWin(wrcd)		/* From MyCloseWindow */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			if((*wrcd) == (*dbugWin))	/* CATCH CLOSING DEBUG WINDOW */
				dbugWin = NULL;
			TEDispose( (*wrcd)->w.te.TEH );
			break;
		case TGraphWin:
			TGdispose(wrcd);
			break;
		default:
			break;
		}
	}


NewWind(wrcd)		/* From MyNewWindow */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			NewTEwin(wrcd);
			break;
		case TGraphWin:
			NewTGwin(wrcd);
			break;
		default:
			break;
		}
	}

int ReadFile(wrcd, fn)		/* After db.file.c  */
	WINRCD		**wrcd;
	Str255 		fn;
	{
	int	rc = 0;

	switch( (*wrcd)->winType )
		{
		case TEWin:
			rc = ReadTEfile(wrcd, fn );
			break;
		case TGraphWin:
			rc = ReadTGfile(wrcd, fn );
			break;
		default:
			break;
		}
	return(rc);
	}

Win(wrcd)		/* From  */
	WINRCD		**wrcd;
	{
	switch( (*wrcd)->winType )
		{
		case TEWin:
			break;
		default:
			break;
		}
	}


