/*******************************************************************\
*																	*
*	db.file.c														*
*																	*	
*	file functions for DSPbench										*
*																	*
*	29mar90	dpwe													*
*																	*
\*******************************************************************/
	
#include "DSPbench.h"

SetUpFiles()
{
/* Don't know what to do here */
}

pStrCopy( p1, Sp2 )
/* register */ char *p1;
         Str255 Sp2;
/* copies a pascal string from p1 to p2 */
	{
	register char *p2;
	register int len;
	
	p2 = (char *)Sp2;
	len = *p2++ = *p1++;
	while (--len>=0) *p2++=*p1++;
	}

int DoFile( item )
int		item;

	{
	int 	vRef, io, ftype;
    short   refNum;
    
	Str255	fn;

	switch (item)
	{
	case fmNew: 
		pStrCopy((char *)"\pOntitled",fn);
		winRoot = MyNewWindow(winRoot,fn, TGraphWin);
		break;
	case fmOpen:
		if (OldFile(fn, &vRef, &ftype ))
		OpenFile(fn,vRef,ftype);
		break;
	case fmClose:
		if ((frntWin) && (*frntWin)->dirty) {
			HLock((Handle)frntWin);
			ParamText((unsigned char *)"\pSave changes for ",
					((*frntWin)->theFileName[0]==0) ? "\pUntitled" :
										(*frntWin)->theFileName,
										"\p?", 
										"\p");
			HUnlock((Handle)frntWin);
			switch (Alert(AdviseAlert, 0L)) {
			case aaSave:
				if ((*frntWin)->theFileName[0]==0) {
					fn[0] = 0;
					if (!SaveAs(fn, &vRef, frntWin)) return(0);
				}
	 			else
	 				if (!SaveFile( frntWin )) return(0);
	 			break;
	 		case aaCancel: return(0);
	 		case aaDiscard: (*frntWin)->dirty = 0;
	 		}
	 	}
	 	if(frntWin)
	 		{
			MyCloseWindow(frntWin);
			frntWin = ours((WindowPtr)FrontWindow());
			}
		break;
	case fmSave:
		if ((*frntWin)->theFileName[0]==0) goto saveas;
		SaveFile(frntWin);
		break;
	case fmSaveAs:
saveas:
		fn[0] = 0;
		if (SaveAs(fn, &vRef, frntWin )) {
			pStrCopy((char *)fn, (*frntWin)->theFileName);
			(*frntWin)->theVRefNum = vRef;
			SetWTitle((*frntWin)->myWindow, (*frntWin)->theFileName);
		}
		break;
	case fmRevert:
		ParamText("\pRevert to last saved version of ",
				(*frntWin)->theFileName, "\p?", "\p");
		switch (Alert(AdviseAlert, 0L)) {
		case aaSave:
			HidePen();
			TESetSelect( 0, (**(*frntWin)->w.te.TEH).teLength, (*frntWin)->w.te.TEH );
			ShowPen();
			TEDelete((*frntWin)->w.te.TEH);
			if (((*frntWin)->theFileName[0]!=0) &&
				(FSOpen((*frntWin)->theFileName, (*frntWin)->theVRefNum, &refNum)==noErr)) {
			/*	(*frntWin)->dirty = !ReadFile( refNum, (*frntWin)->w.te.TEH ); 	
				! wrong ReadFile - now does soundfiles, not TE's  dpwe 1992may18 */
				/* I don't check for bad read! */
				if (FSClose(refNum)==noErr) ;
			}
			ShowWindow( (*frntWin)->myWindow );
			UpdateWindow( frntWin );
 		case aaCancel:
 		case aaDiscard: return(0);;
 		}

		break;
	case fmPageSetUp:
		DoPageSetUp();
		break;
	case fmPrint:
		PrintText( (**(*frntWin)->w.te.TEH).hText, (long)(**(*frntWin)->w.te.TEH).teLength,
				 (GrafPtr)(*frntWin)->myWindow,
						StringWidth("\pmmmm"), 0L);
		break;
	case fmQuit: 
		if (DoFile(fmClose)) ExitToShell();
	}
	return(1);
}

OpenFile(Str255 fn, int vRef, int ftype)
	{
	int refNum;
	int	err = 0;

		winRoot = MyNewWindow(winRoot, fn, ftype);
		(*winRoot)->theVRefNum = vRef;
		(*winRoot)->dirty = 0;
		HLock((Handle)winRoot);
		err = ReadFile( winRoot, fn );
		HUnlock((Handle)winRoot);
		if(err)
			{
			MyCloseWindow(winRoot);
			frntWin = ours((WindowPtr)FrontWindow());
			}
	}

static Point SFGwhere = { 90, 82 };
static Point SFPwhere = { 106, 104 };
static SFReply reply;

SaveAs( fn, vRef, wrcd )
Str255 	fn;
int		*vRef;
WINRCD	**wrcd;
{
	short refNum;
	
	if (NewFile(fn, vRef)) 
		if (CreateFile(fn, vRef, &refNum)) {
			WriteFile(refNum, (*(**(*wrcd)->w.te.TEH).hText), (long)(**(*wrcd)->w.te.TEH).teLength);
			FSClose( refNum );
			(*wrcd)->dirty = 0;
			return(1);
		}
		else {
			FileError("\pError creating file ", fn);
		}
	return(0);
}

SaveFile( wrcd )
	WINRCD	**wrcd;
	{
	Str255	fn;
	int		vrn;
	short	refNum;
	
	pStrCopy((char *)(*wrcd)->theFileName, fn);
	vrn = (*wrcd)->theVRefNum;
	if (FSOpen( fn, vrn, &refNum )==noErr) {
		WriteFile(refNum, (*(**(*wrcd)->w.te.TEH).hText), (long)(**(*wrcd)->w.te.TEH).teLength);
		(*wrcd)->dirty = 0;
		FSClose( refNum );
		return(1);
	}
	else FileError("\pError opening file ", fn);
	return(0);
	}

NewFile( fn, vRef )
Str255	fn;
int		*vRef;
	{
	SFPutFile(SFPwhere, "\p", fn, 0L, &reply);
	if (reply.good)
		{
		pStrCopy((char *)reply.fName, fn);
		*vRef = reply.vRefNum;
		return(1);
		}
	else return(0);
	}

extern long sndfType;		/* defined in sndf*.c */

OldFile( fn, vRef, type )
Str255	fn;
int		*vRef;
int 	*type;		/* returns (internal) type */
	{
	SFTypeList	myTypes;	
	long	soundFileType = sndfType; /* (long)'AIFF';	/* or Sd2f for SD files */
	long	textFileType = (long)'TEXT';
	
/*	myTypes[0]= soundFileType;	*/
/*	myTypes[1]='TEXT';	/* TEXT IS IGNORED WHILST # TYPES == 1 */
	/* new style is to attempt read AIFF, else read raw with assumed fmt */
	/* .. which will work for sd2's */
	myTypes[0] = 'Sd2f';
	myTypes[1] = 'AIFF';
	myTypes[2] = textFileType;	/* why not? */
	SFGetFile( SFGwhere, "\p", 0L, 3 /* !! # types */, myTypes, 0L, &reply );
	if (reply.good)
		{
		pStrCopy( (char *)reply.fName, fn );
		*vRef = reply.vRefNum;
/*		if(reply.fType == soundFileType)	*type = TGraphWin;	*/
/*		else						*type = TEWin;			/* for now */
/*		if(reply.fType == textFileType)		*type = TEWin;	*/
/*		else		*/
		/* no - open everything as a sound! */
			*type = TGraphWin;
		return(1);
		}
	else return(0);
	}

CreateFile( fn, vRef, theRef )
Str255	fn;
int		*vRef;
short	*theRef;
	{
	int io;
	
	io=Create(fn, *vRef, 'CEM8', 'TEXT');
	if ((io==noErr) || (io==dupFNErr)) io = FSOpen( fn, *vRef, theRef );
	return( (io==noErr) || (io=dupFNErr) );
	}

WriteFile( refNum, p, num )
int		refNum;
char	*p;
long	num;
	{
	int io;			/* 	a real application would want to check 
						this return code for failures */
	
	io=FSWrite( refNum, &num, p );
	}

FileError( s, f )
unsigned char *s;
Str255 f;
	{
	ParamText(s, f,"\p", "\p");
	Alert( ErrorAlert, 0L );
	}
