/***********************************************************************\
*																		*
*	DSPbench.c		(after MiniEdit.c)									*
*																		*
*	First attempt at an in-house graphical DSP workbench.				*
*																		*
*	29mar90	dpwe														*
*																		*
\***********************************************************************/

#include "DSPbench.h"

/* prototypes */
extern OpenFile(Str255 fn, int vRef, int ftype);

MenuHandle		myMenus[4];
Cursor			editCursor;
Cursor			waitCursor;
Cursor			pauseCursor;
Cursor			xCursor;
WINRCD			**winRoot = NULL;
WINRCD			**frntWin = NULL;
WINRCD			**dbugWin = NULL;

/* globals */
char	*programName = "dspB";
char	sfdir_path[] = "Frida:dpwe:sound";
int 	done = FALSE;
/* doesn't do anyhting right now on Mac */
int		forceChans = 0;
double		minTrackDB = -50.0;	
/* minimum peak mag of tracks to display - see db.peaks.c */

extern long sndfType;

main() 
{
	int		myRsrc;
	short	opOrPr, nFiles, i;
	AppFile	theFile;
	
	InitGraf(&thePort);
	InitFonts();
	FlushEvents( everyEvent, 0 );
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	InitCursor();
	MaxApplZone();

/*
/*  The following statement is included as a check to see if we can
/*	access our program's resources.  When the project is run from
/*	LightspeedC, the resource file <project name>.rsrc is automatically
/*  opened.  When an application is built, these resources are 
/* 	automatically merged with the application.
/*
*/
	
	if (GetResource('MENU', fileID)==0) {
		SysBeep(20);
		CantOpen();
		return;
	}
	
	SetUpFiles();
	SetUpCursors();
	SetUpMenus();
	SetUpWindows();
	CountAppFiles(&opOrPr, &nFiles);
	for(i=1; i<=nFiles; ++i)
		{
		GetAppFiles(i, &theFile);
		if(opOrPr == 0)
			OpenFile(theFile.fName, theFile.vRefNum, TGraphWin);
			/*	(theFile.fType==sndfType)? TGraphWin : TEWin);	*/
		ClrAppFiles(i);
		}
	if(opOrPr == 0)  {
		Banner();
		do	{
			done = 0;
			do {  MainEvent();  } while(!done);
			} while(!DoFile(fmClose));
		}
	ExitToShell();
}

extern char *version;
extern char *versiondate;
extern char *builddate;

Banner(void)
{	/* startup banner identifies mac version */
	D_prints("dspBench  --  A sound viewer and research workbench\n");
	D_prints("   version: ");	D_prints(versiondate);
	D_prints("  "); 			D_prints(version);   D_prints("\n");
	D_prints("build date: ");	D_prints(builddate); D_prints("\n");
	D_prints("Copyright(c)1990-3 Dan Ellis/MIT Media Lab. All rights reserved\n");
}

int MainEvent() 
{
	EventRecord		myEvent;
	WindowPtr		whichWindow;
	WINRCD			**myWrcd;
	
	MaintainCursor();
	MaintainMenus();
	SystemTask();
	if(frntWin)
		Idle(frntWin);
	if (GetNextEvent(everyEvent, &myEvent)) {
		switch (myEvent.what) {
		case mouseDown:
			switch (FindWindow( myEvent.where, &whichWindow )) {
			case inDesk: 
				SysBeep(10);
				break;
			case inGoAway:
				if (myWrcd=ours(whichWindow))
					if (TrackGoAway( (*myWrcd)->myWindow, myEvent.where) )
						DoFile(fmClose);
				break;
			case inMenuBar:
				return( DoCommand( MenuSelect(myEvent.where) ) );
			case inSysWindow:
				SystemClick( &myEvent, whichWindow );
				break;
			case inDrag:
				if (myWrcd=ours(whichWindow))
					{
					HLock((Handle)myWrcd);
					DragWindow( (*myWrcd)->myWindow, myEvent.where, &(*myWrcd)->dragRect );
					HUnlock((Handle)myWrcd);
					}
				break;
			case inGrow:
				if (myWrcd=ours(whichWindow))
					MyGrowWindow( myWrcd, myEvent.where );
				break;
			case inContent:
				if (whichWindow != FrontWindow())
					{
					SelectWindow(whichWindow);
					frntWin = ours(whichWindow);
					}
				else 
					if (myWrcd=ours(whichWindow))
						DoClickInConts(myWrcd, &myEvent);
				break;
			default: ;
			} /* end switch FindWindow */
			break;
		case keyDown:
		case autoKey: 
			{
			register char	theChar;
			
			theChar = myEvent.message & charCodeMask;
			if ((myEvent.modifiers & cmdKey) != 0) 
				return( DoCommand( MenuKey( theChar ) ));
			else
				DoKeyDown(frntWin, theChar);
			}
			break;
		case activateEvt:
			DoActivate(myEvent);
			break;
		case updateEvt: 
			if (myWrcd = ours((WindowPtr)myEvent.message))
				UpdateWindow(myWrcd);
			break;
		default: ;
		} /* end of case myEvent.what */
	} /* if */
	return(1);
}

DoActivate(myEvent)
	EventRecord		myEvent;
	{
	Rect			r;
	WINRCD			**myWrcd;

	if (myWrcd=ours((WindowPtr)myEvent.message))
		{
	/*	r = ((*myWrcd)->myWindow)->portRect;	/*	*/
	/*	r.bottom -= (SBarWidth+1);		/*	*/
	/*	r.right -= (SBarWidth+1);		/* was r.left : no idea what it's doing */
	/*	InvalRect(&r);		/* Tried a sensible looking fix: just user area */
	/* Above code tends to crash on closing windows - so forget it! */
		if ( myEvent.modifiers & activeFlag )
			{
			ActivateWin( myWrcd );
			frntWin = myWrcd;
			}
		else
			DeactivateWin( myWrcd );
		}
	}

SetUpMenus()
{
	int		i;
	
	myMenus[appleM] = NewMenu( appleID, "\p\024" );
	AddResMenu( myMenus[appleM], 'DRVR' );
	myMenus[fileM] = GetMenu(fileID);
	myMenus[editM] = GetMenu(editID);
	myMenus[viewM] = GetMenu(viewID);
	for ( (i=appleM); (i<=viewM); i++ ) InsertMenu(myMenus[i], 0) ;
	DrawMenuBar();
}

int DoCommand( mResult )
long mResult;
{
	int		theItem, temp;
	Str255	name;
	WindowPeek wPtr;
	
	theItem = LoWord( mResult );
	switch (HiWord(mResult)) {
	case appleID:
		GetItem(myMenus[appleM], theItem, name);
		OpenDeskAcc( name );
		SetPort( (*frntWin)->myWindow );
		break;
	case fileID: 
		DoFile(theItem);
		break;
	case editID: 
		if (SystemEdit(theItem-1)==0) {
			switch (theItem) {
			case undoCommand:
				UndoInWin( frntWin );
				break;
			case cutCommand:
				CutInWin( frntWin );
				break;
			case copyCommand:
				CopyInWin( frntWin );
				break;
			case pasteCommand:
				PasteInWin( frntWin );
				break;
			case clearCommand:
				ClearInWin(frntWin);
				break;
			default: ;
			}
		}
		break;
	case viewID:
		DoMenuItem(frntWin,theItem);
		break;
	}
	HiliteMenu(0);
	return(1);
}

MaintainCursor()
	{
	Point		pt;
	WindowPeek	wPtr;
	GrafPtr		savePort;
	
	if (frntWin = ours((WindowPtr)(wPtr=(WindowPeek)FrontWindow()))) {
		GetPort( &savePort );
		SetPort( (GrafPtr)wPtr );
		GetMouse(&pt);
		switch( (*frntWin)->winType)
			{
			case TEWin:
				if ( PtInRect(pt, &(**((*frntWin)->w.te.TEH)).viewRect )  )
					SetCursor( &editCursor);
				else SetCursor( &arrow );
				break;
			default:
				break;
			}
		SetPort( savePort );
		}
	}

MaintainMenus()
	{
	if ( (winRoot == NULL) || 
			(frntWin=ours(FrontWindow()))==NULL )
		{
		EnableItem( myMenus[fileM], fmNew );
		EnableItem( myMenus[fileM], fmOpen );
		DisableItem( myMenus[fileM], fmClose );
		DisableItem( myMenus[fileM], fmSave );
		DisableItem( myMenus[fileM], fmSaveAs );
		DisableItem( myMenus[fileM], fmRevert );
		DisableItem( myMenus[fileM], fmPrint );
		EnableItem( myMenus[editM], undoCommand );
		EnableItem( myMenus[editM], cutCommand );
		EnableItem( myMenus[editM], copyCommand );
		EnableItem( myMenus[editM], clearCommand );
		}
	else{
		EnableItem( myMenus[fileM], fmNew );
		EnableItem( myMenus[fileM], fmOpen );
		EnableItem( myMenus[fileM], fmClose );
		EnableItem( myMenus[fileM], fmSaveAs );
		EnableItem( myMenus[fileM], fmPrint );
		if ((*frntWin)->dirty && (*frntWin)->theFileName[0] != 0)
			{
			EnableItem( myMenus[fileM], fmRevert );
			EnableItem( myMenus[fileM], fmSave );
			}
		else{
			DisableItem( myMenus[fileM], fmRevert );
			DisableItem( myMenus[fileM], fmSave );
			}
		if((*frntWin)->winType == TEWin)
			DisableItem( myMenus[editM], undoCommand );
		else
			EnableItem( myMenus[editM], undoCommand );
		if ( ((*frntWin)->winType == TEWin)&&
				((**((*frntWin)->w.te.TEH)).selStart==(**((*frntWin)->w.te.TEH)).selEnd) )
			{
			DisableItem( myMenus[editM], cutCommand );
			DisableItem( myMenus[editM], copyCommand );
			DisableItem( myMenus[editM], clearCommand );
			}
		else{
			EnableItem( myMenus[editM], cutCommand );
			EnableItem( myMenus[editM], copyCommand );
			EnableItem( myMenus[editM], clearCommand );
			}
		}
	}

SetUpCursors()
	{
	CursHandle	hCurs;
	
	hCurs = GetCursor(1);
	editCursor = **hCurs;
	hCurs = GetCursor(watchCursor);
	waitCursor = **hCurs;
	hCurs = GetCursor(crossCursor);
	xCursor = **hCurs;
	hCurs = GetCursor(watchCursor);
	pauseCursor = **hCurs;
	}

WINRCD **ours(w)
WindowPtr w;
	{
	WINRCD **pwr;

	pwr = winRoot;
	while(pwr != NULL)
		{
		if(((*pwr)->myWindow != NULL) &&((*pwr)->myWindow == w))
			return( pwr );
		pwr = (*pwr)->nextHan;
		}
	return(NULL);				/* just break; & return pwr would prob. do */
	}

CantOpen()
	{
	Rect 			r;
	WindowPtr		win;


	SetRect(&r, 152, 60, 356, 132);
	SetPort((win = NewWindow( 0L, &r, "\p", 1, 1, (WindowPtr)-1L, 0, 0L)));
	TextFont(0);
	MoveTo( 4, 20 );
	DrawString("\pCan't open resource file.");
	MoveTo( 4, 40 );
	DrawString("\pClick mouse to exit.");
	do {
	} while ( !Button() );
	}

void psyDisp(prec, stt, end, chans, frqv)
    Rect *prec;
    short *stt;
    short *end;
    int   chans;
    FRQVIEW *frqv;
    {
	MarkX(prec);
	}

/* record and extract exactly as in db.xmain.c */

record(stt,end,chans,dsize,srate,scale)	/* called from main place */
    short   *stt;
    short   *end;
    int     chans;
    int     dsize;    /* ignored - assumed = sizeof(short) in what follows */
    float   srate;    /***** NO RESAMPLING if != 8000 Hz - just wrong pitch */
    int     scale;    /* crude integer scale factor; 2 => no scaling */
    {
    D_prints("We're sorry.");
    D_prints("Your call cannot be completed as dialled.");
    }

/* characteristics for temporary extract sound */
#define TMPDIR ""
#define TMPSND "tmp"

xtract(stt,end,chans,dsize,srate,scale)	/* called from main place */
    short   *stt;
    short   *end;
    int     chans;
    int     dsize;    /* ignored - assumed = sizeof(short) in what follows */
    float   srate;
    int     scale;    /* crude integer scale factor; 2 => no scaling */
    {
    long	outBSize,outBRem;
    int 	format;
    int 	c;
    long	d;
    short	*ptr1;
    short	*ptr2;
    SFSTRUCT	*tmpSound;
    long	nblocks;
    int 	thisBlSiz;
    FILE	*op;
    char 	tmpSndName[80];
    int err;

    sprintf(tmpSndName, "%s%s%s", TMPDIR, TMPSND, sndfExtn);
    outBSize = (((long)(end-stt))*sizeof(short));
    /* assu short *stt etc, o/p short */
    format = SFMT_SHORT;
    /*	printf("Allocate %ld bytes, format %d, srat %ld\n",outBSize,
	format, (long)srate);	/*  */
    if(err = SFAlloc(&tmpSound, outBSize, format, srate, chans, 4))
	{
	fprintf(stderr,"%s: sound error %s\n", programName,
		SFErrMsg(err));
	exit(1);
	}
    ptr1 = stt;
    ptr2 = (short *)SFDataLoc(tmpSound);
    while(ptr1<end)		/* copy whole to a new  sound */
	{
	*ptr2++ = *ptr1++;
	}
    if(err = SFWrite(tmpSndName, tmpSound))
	{
	fprintf(stderr,"%s: sound error %s\n", programName,
		SFErrMsg(err));
	exit(1);
	}
	D_prints("region extracted to ");
	D_prints(tmpSndName);
	D_printn(outBSize);
    SFFree(tmpSound);
    }

