/*******************************************************************\
*	db.menu.c						    *
*	DIY menu bar for dspBench				    *
*	01oct90	dpwe	      					    *
\*******************************************************************/

#include <stdio.h>

#include "DSPbench.h"
#include "db.menu.h"

#ifndef THINK_C
extern Display *disp;		/* for a single XFlush */
#endif
extern  int     done;

/* globals */
/* name, submenu, nextitm, id */
#ifdef TRAX
static MNUITM m34= { "Prom",  NULL, NULL, gProm ,0 };
static MNUITM m33= { "Grow",  NULL, &m34, gGrow ,0 };
static MNUITM m40= { "newNs", NULL, &m33, gNois2 ,0 };
static MNUITM m38= { "Noise", NULL, &m40, gNoise ,0 };
static MNUITM m37= { "Meta",  NULL, &m38, gMeta ,0 };
static MNUITM m36= { "Harmn", NULL, &m37, gHarm ,0 };
static MNUITM m35= { "Onset", NULL, &m36, gOnset ,0 };
static MNUITM m39= { "All",   NULL, &m35, gOther ,0 };
static MNUITM m32= { "Group", &m39, NULL, groupM ,0 };

static MNUITM m30= { "TrackRV", NULL, NULL, tExspc ,0 };    
static MNUITM m42= { "-",     NULL, &m30, 0, MF_DISABLED };
static MNUITM m20= { "Thrsh", NULL, &m42, tTrack ,0 };
static MNUITM m31= { "SaveT", NULL, &m20, tSaveT ,0 };
static MNUITM m26= { "WritL", NULL, &m31, tSave ,0 };
static MNUITM m25= { "ReadL", NULL, &m26, tLoad ,0 };
static MNUITM m27= { "Print", NULL, &m25, tPrint ,0 };
static MNUITM m19= { "Reset", NULL, &m27, tReset ,0 };
/* static MNUITM m18= { "Synth", NULL, &m19, tSynth ,0 }; */
static MNUITM m21= { "Trax",  &m19, &m32, traxM ,0 };
#define TRMENU	&m21
#else
#define TRMENU NULL
#endif

#ifdef PSYAC
static MNUITM m29= { "PsychoAcoustic", NULL, NULL, vPsyAc ,0 };
static MNUITM m17= { "Spectrogram", NULL,&m29,vPvoc ,0 };
#else /* no PSYAC */
static MNUITM m41= { "Show phase", NULL,NULL,vPhase ,0 };
static MNUITM m43= { "-",     NULL, &m41, 0, MF_DISABLED };
static MNUITM m17= { "Spectrogram", NULL,&m43,vPvoc ,0 };
#endif /* def PSYAC */
static MNUITM m14= { "STFT waterfall", NULL, &m17,vFourFrm ,0 };
static MNUITM m28= { "STFT frame", NULL, &m14,vOneFrm ,0 };
static MNUITM m16= { "Fourier tf", NULL, &m28,vFourier ,0 };
static MNUITM m2 = { "TD Waterfall", NULL,&m16,vWaterf ,0 };
static MNUITM m1 = { "Normal", NULL,&m2,vNormal ,0 };
static MNUITM m3 = { "View", &m1,TRMENU,viewM ,0 };

static MNUITM m4 = { "Paste", NULL,NULL,4 ,MF_DISABLED };
static MNUITM m5 = { "Copy", NULL,&m4,5 ,MF_DISABLED };
static MNUITM m6 = { "Cut", NULL,&m5,6 ,MF_DISABLED };
static MNUITM m7 = { "-", NULL,&m6,7 , MF_DISABLED };
static MNUITM m8 = { "Undo", NULL,&m7,8 ,MF_DISABLED };
static MNUITM m9 = { "Edit", &m8,&m3,editM ,MF_DISABLED };

static MNUITM m15 = { "Quit", NULL,NULL,fmQuit ,0 };
static MNUITM m22 = { "-", NULL,&m15, 22, MF_DISABLED };
static MNUITM m23 = { "About", NULL,&m22, mAbout,0 };
static MNUITM m24 = { "-", NULL,&m23, 24, MF_DISABLED };
static MNUITM m10 = { "Close", NULL,&m24,10 ,MF_DISABLED };
static MNUITM m11 = { "Open", NULL,&m10,11 ,MF_DISABLED };
static MNUITM m12 = { "New", NULL,&m11,12 ,MF_DISABLED };
static MNUITM m13 = { "File", &m12,&m9,fileM ,0 };

/* prototypes */

/* implementations */

#define MNUGAPW		24      /* pixel gap between menu entries */
/* #define MNULINH		16	/* pixel line height in vert mnus */

static int MNULINH = 0;

static int mnuGetSetFlags(MNUITM *root, int menuID, int flags)
{   /* set the flags of the menu item whose ID is <menuID> to <flags>;
       return the previous state */
    int prevflags;

    if(root == NULL)	root = &m13;	/* the actual root */
    while(root != NULL)  {
	if(root->id == menuID)  {
	    prevflags = root->flags;
	    root->flags = flags;
	    return prevflags;
	} else {
	    /* depth-first search */
	    if(root->submenu)  {
		if(prevflags = mnuGetSetFlags(root->submenu, menuID, flags)
		    >= 0)  {
		    return prevflags;
		}
	    }
	    root = root->nextitm;
	}
    }
    return -1; 	/* not in this menu tree - return not-found code */
}

DrawMBar(wrcd,rec)
    WINRCD **wrcd;
    Rect   rec;
    {
#ifdef THINK_C
    FrameRect(&rec);
#else
    MNULINH = 1.2*LineHeight();
    DrawMenuBar(rec, &m13);
#endif
    }

int
MClick(wrcd, rec, clik /*WINRCD **wrcd, Rect rec, Point clik*/)
    WINRCD	**wrcd;
    Rect	rec;
    Point	clik;
    {
    int i;
#ifdef THINK_C
    return 0;
#else
    i = MenuClick((*wrcd)->myWindow,rec, clik, &m13);
    return i;
#endif
    }

DoMenuItem(wrcd,id)		/* passed result of menu bar interaction */
    WINRCD **wrcd;
    int    id;
    {
    extern char *builddate;	/* compiled in as `date` at buildtime */
    extern char *version;
    extern char *versiondate;	/* hand-edited comments may describe vsn */
    extern int  deferShout;	/* flag to hold shout box (for msg) */
    extern int  showPhase;	/* in db.sgram.c, show mag or phase sgram */

    switch(id)
	{
    case vNormal:	 /* view normal */
	(*wrcd)->w.snd.vMode = (int)multiVM;
	RedrawWinBit(wrcd, Sviewid);
	break;
    case vWaterf:	/* view waterfall */
	(*wrcd)->w.snd.vMode = (int)wfallVM;
	RedrawWinBit(wrcd, Sviewid);
	break;
    case vPvoc:		/* view spectrogram */
	(*wrcd)->w.snd.vMode = (int)spgrmVM;
	RedrawWinBit(wrcd, Sviewid);
	break;
    case vPhase:	/* view spectrogram as phases, not magnitudes */
	if(ShowPhases(wrcd)) {
	    mnuGetSetFlags(NULL, vPhase, MF_SELECTED);
	} else {
	    mnuGetSetFlags(NULL, vPhase, 0);
	}
	break;
    case vPsyAc:	/* view psychoacoustic display */
	(*wrcd)->w.snd.vMode = (int)psyDispVM;
	RedrawWinBit(wrcd, Sviewid);
	break;
    case vFourier:	/* view fourier transform */
	(*wrcd)->w.snd.vMode = (int)ftVM;
	RedrawWinBit(wrcd, Sviewid);
	break;
    case vFourFrm:	/* view fourier transform */
	(*wrcd)->w.snd.vMode = (int)specVM;
	RedrawWinBit(wrcd, Sviewid);
	break;
    case vOneFrm:	/* view single frame from pvoc file */
	(*wrcd)->w.snd.vMode = (int)onefrVM;
	RedrawWinBit(wrcd, Sviewid);
	break;
#ifdef TRAX
    case tTrack:	/* frequently reused field */
	/* WriteTrxSumm(wrcd); */
	/* FindNoiseM(wrcd);	/* new noise-region stuff 1993apr25 */
	/* FindHarmsM(wrcd);	/* harmonic tracking stuff */
	ThreshSel(wrcd);	/* remove bottom 5dB of tracks */
	break;
    case tReset:	/* reset track selections */
	ResetTracks(wrcd);
	break;
    case tSynth:	/* synthesise temp sound from selected tracks */
	SynthFromTracks(wrcd);
	break;
    case tLoad:		/* Read in track selection list */
	TrackReadSel(wrcd);
	break;
    case tSave:		/* Write out track selection list */
	TrackWriteSel(wrcd);
	break;
    case tPrint:	/* print details of selected tracks to screen */
	PrintSelTrax(wrcd);
	break;
    case tExspc:	/* Do expected spectrum thang (db.exspec.c) */
	if(RevealTrax(wrcd))  {
	    mnuGetSetFlags(NULL, tExspc, MF_SELECTED);
	} else {
	    mnuGetSetFlags(NULL, tExspc, 0);
	}
	break;
    case tSaveT:        /* write out trax file */
	TrackSaveSel(wrcd);
	break;
    case gGrow:
	GrowTrax(wrcd);	   /* or the GrowTrax thing, or whatever's in vogue */
	break;
    case gProm:
	PromTrax(wrcd);
	break;
    case gOnset:
	FindOnsetsM(wrcd);
	break;
    case gHarm:
	FindHarmsM(wrcd);
	break;
    case gMeta:
	DoMetaM(wrcd);
	break;
    case gNoise:
	FindNoiseM(wrcd);
	break;
    case gNois2:
	NewNoiseM(wrcd);
	break;
    case gOther:
/*	CalcPromM(wrcd);	*/
/*	CheckOnsetM(wrcd);      */
/*	CheckSuccsM(wrcd);	*/
	tgGenAll(wrcd);		
	break;
#endif

#ifndef THINK_C		/* no pathetic about on mac */
    case mAbout:	/* about box */
	shout("Dan Ellis","MIT Media Lab", versiondate, version);
	deferShout = 1;		/* avoid it getting overwritten */
	D_prints("\n");
	D_prints("   dspBench\n");
	D_prints("   --------\n");
	D_prints("   version: ");	D_prints(version);  D_prints("\n");
	D_prints("  ver date: ");	D_prints(versiondate); D_prints("\n");
	D_prints("build date: ");	D_prints(builddate); D_prints("\n");
	D_prints("\n");
	D_prints("A sound editor and research workbench under X windows\n");
	D_prints(
"Copyright (c) 1990-3 Dan Ellis & MIT Media Lab.  All rights reserved.\n");
	D_prints(
"Permission to use, copy, or modify these programs for educational and\n");
	D_prints(
"research purposes only and without fee is hereby granted, provided that\n");
	D_prints(
"this copyright and permission notice appear on all copies.  For any other\n");
	D_prints(
"uses of this software, in original or modified form, including but not\n");
	D_prints(
"limited to distribution in whole or in part, specific prior permission\n");
	D_prints(
"from M.I.T. must be obtained.  M.I.T. makes no representations about the\n");
	D_prints(
"suitability of this software for any purpose.  It is provided 'as is',\n");
	D_prints(
"without express or implied warranty.\n");
	D_prints("\n");
	D_prints("Bugs, comments, questions to dpwe@media.mit.edu\n");
	D_prints("Include 'dspB' in the title line.\n");
	break;
#endif /* ndef THINK_C */
    case fmQuit:	/* quit */
	done = 1;	/* cease! */
	break;
    default:
	break;
	}
    }

#ifndef THINK_C

extern Pixmap tickIcon;

DrawMenuBar(r, menu)	/* draw up a menu bar */
    Rect r;
    MNUITM *menu;
    {
    int	offsx;
    int x,y;
    char *s;
    PenState penstate;

    EraseRect(&r);
    offsx = MNUGAPW / 2;	/* start off half a gap in */
    while(menu != NULL)
	{
	x = r.left + offsx;
	y = r.top;
	s = menu->name;
        if(menu->flags & MF_DISABLED)
            SetStipplePen(&penstate);
	WriteString(x,y,s);
        if(menu->flags & MF_DISABLED)
	    RestoreSolidCopyPen(&penstate);
	offsx += myTextWidth(menu->name) + MNUGAPW;
	menu = menu->nextitm;
	}
    }

Window				/* returns handle to bit popped up */
PopUpMenu(par,x,y,menu /*int x, int y, MNUITM *menu*/)
    Window par;
    int x,y;
    MNUITM *menu;
    {
    int     width=0, maxw = 0;
    int     entries = 0;
    MNUITM  *itm;
    Window  w, PopNewWindow();
    int	    cwidth = myTextWidth(" ");
    PenState penstate;
    Rect    rct;

    itm = menu->submenu;
    /* find max width */
    while(itm != NULL)
	{
	width = myTextWidth(itm->name);
	if(width > maxw)   maxw = width;
	++entries;
	itm = itm->nextitm;
	}
    SetPort(par); 
    maxw += MNUGAPW + cwidth*2;
    entries *= MNULINH;
    w = PopNewWindow(par,x,y,maxw,entries);
    itm = menu->submenu;
    x = 0;
    y = 0;
    x += MNUGAPW/2 + cwidth;
    /* y += ? */
    rct.left = cwidth/2; rct.right = rct.left+2*cwidth;
    while(itm!=NULL)  {
	if(itm->name[0] == '-')  {
	    SetDottedPen(&penstate);
	    MoveTo(0, y+MNULINH/2);
	    LineTo(maxw, y+MNULINH/2);
	    RestoreSolidCopyPen(&penstate);
	} else {
	    if(itm->flags & MF_SELECTED)  {
		rct.top = y;
		rct.bottom = rct.top + MNULINH;
		ShowIcon(rct, tickIcon);  
	    }		
	    if(itm->flags & MF_DISABLED)
		SetStipplePen(&penstate);
	    WriteString(x,y,itm->name);
	    if(itm->flags & MF_DISABLED)
		RestoreSolidCopyPen(&penstate);
	}
	y += MNULINH;
	itm = itm->nextitm;
    }
    XFlush(disp);
    return(w);
}

UnPopMenu(w /* Window w */)
    Window w;
    {
    UnpopWindow(w);
    }

int		/* returns menu entry i.d. */
MenuClick(par,r,p,menu /* Rect r, Point p, MNUITM *menu*/)	/* mouse down in m-bar */
    Window par;
    Rect r;
    Point p;
    MNUITM *menu;
    {
    int  w;
    Rect titleR;
    int  rc;
    MNUITM *thisMenu;

    do  {
	/* choose a menu */
	titleR = r;
	thisMenu = menu;
	while(thisMenu != NULL)
	    {
	    w = myTextWidth(thisMenu->name)+MNUGAPW;
	    if( titleR.left + w > p.h )
		{
		titleR.right = titleR.left+w;
		break;
		}
	    else
		{
		thisMenu = thisMenu->nextitm;
		titleR.left += w;
		}
	    }
	rc = PopAndTrackMenu(par,thisMenu,titleR,r,&p );
	}while(rc<0);
    if(rc>0)
	{
	thisMenu = thisMenu->submenu;
	while(--rc)
	    thisMenu = thisMenu->nextitm;
	rc = thisMenu->id;
	}
    return(rc);
    }

int		/* returns menu entry i.d. */
PopAndTrackMenu(par,menu,titleR,otherMenuR,pmspt)
    Window par;	/* parent window */
    MNUITM *menu;
    Rect   titleR, otherMenuR;
    Point  *pmspt;
    {
    int	x,y;
    Window w;
    Point  pt;
    int    line = 0;
    int    oldLine;
    PenState ps;
    Point  org;

    x = titleR.left;	y = titleR.bottom;
    org.h = x; org.v = y;
    if(menu != NULL)
	{
	SetDottedXorPen(&ps);	/* invert title */
	PaintRect(&titleR);
	RestoreSolidCopyPen(&ps);
	w = PopUpMenu(par,x,y,menu);
	}
    /* track mouse */
    /* perhaps popup submenus */
    /* return code of i.d. on mouse release or perhaps none */
    SetPort(par);
    if(StillDown())
	{
	while(WaitMouseUp())
	    {
	    GetMouse(&pt);
	    SetPort(w);
	    oldLine = (line>0)? line : 0;
	    line = GetMenuLine(w,menu,pt,org);
	    if(oldLine && oldLine != line)
		UnmarkMenuLine(w,menu,oldLine,org);
	    if(line && oldLine != line)
		MarkMenuLine(w,menu,line,org);
	    SetPort(par);

	    if((!PtInRect(pt,&titleR)) && PtInRect(pt,&otherMenuR))
		{
		line = -1;
		break;
		}
	    }
	}
    if(menu != NULL)
	{
	UnPopMenu(w);
	SetDottedXorPen(&ps);	/* uninvert title */
	PaintRect(&titleR);
	RestoreSolidCopyPen(&ps);
	}
    *pmspt = pt;
    return(line);
    }

int
GetMenuLine(w,menu,pt,org)
    Window  w;
    MNUITM  *menu;
    Point   pt;
    Point   org;
    {
    Rect    r;

    if(menu == NULL)
	return(0);
    RectOfWin(w,&r);
    OffsetRect(&r,org.h,org.v);
    InsetRect(&r, 1, 1);	/* avoid 'below bottom' m-item */
    if(!PtInRect(pt,&r))
	return(0);	/* not here */
    else
	return(1+(pt.v-r.top)/MNULINH);
    }

MarkMenuLine(w,menu,line,org)
    Window w;
    MNUITM *menu;
    int	   line;
    Point  org;
    {
    Rect   r;
    PenState ps;
    int i;
    MNUITM *ent = menu->submenu;

    RectOfWin(w,&r);
/*    OffsetRect(&r,org.h,org.v);  */
    r.top += MNULINH*(line - 1);
    r.bottom = r.top + MNULINH;
    i = line;
    while(ent != NULL && i > 1)  {
	ent = ent->nextitm;
	--i;
    }
    if( ent && (ent->flags & MF_DISABLED) == 0)  {
	InsetRect(&r,1,1);
	SetDottedXorPen(&ps);
	PaintRect(&r);
	RestoreSolidCopyPen(&ps);
    }
    }

UnmarkMenuLine(w,menu,line,org)
    Window w;
    MNUITM *menu;
    int    line;
    Point  org;
    {
    MarkMenuLine(w,menu,line,org);
    }

#endif /* ndef THINK_C */
