/*******************************************************************\
*   db.peaks.h							    *
*   pick & match spectral peaks for DSPbench	    		    *
*   02apr91 dpwe						    *
\*******************************************************************/

/* other handy things */
/* #include "../llists/llists.h"  now part of DSPbench.h */

/* constants */
#define NPEAKS  64	/* number of peaks we will pick */
#define T_PEAK	100	/* <llist> type identifier for peak node */

/* types */
// typedef struct peakpos 
//    {
//    char	label[16];	/* debug string */
//    float	frq;
//    float	mag;
//    float	phs;
//    float	tim;
//    int 	x,y;		/* scratch screen location */
//    struct peakpos *next;	/* link for temporal evolution ? */
//    } PeakPos;

#include "../trk/peaks.h"

/* prototypes */
#ifdef __STDC__
LIST ListPeaks(float *magfrm, int maginc, float *phsfrm, int phsinc,
	       long len, int sign, FLOATARG time, 
	       FLOATARG binsPOct, FLOATARG frqBase, int logFlg);
LIST PeakListToTrackList(LIST peakList);    /* you get the idea .. */
LIST MatchPeakLists(LIST existingTracks, LIST newPeaks);
    /* extend the track-tails in exTk by attaching els of newPeaks.
       Return the depleted newPeaks if any */
LIST MaintainTracks(LIST *pExistingTracks, LIST leftoverPeaks);
    /* advance existing tracks, remove dead, sort, integrate leftoverPeaks 
       as new tracks, return list pointing to heads of all new tracks */
double TrackOscillator(LIST *track, float *time, float *buf, long num,
		      FLOATARG phi0, int nBins, FLOATARG lowestFrq,
		      FLOATARG	sRate);
#else /* no proto_args */
LIST ListPeaks();
LIST PeakListToTrackList();
LIST MatchPeakLists();
LIST MaintainTracks();
double TrackOscillator();
#endif /* def __STDC__ */
