/*******************************************************************\
*   db.psyac.h							    *
*   Psychoacoustic masking display for dspB			    *
*   1992jul03  dpwe						    *
\*******************************************************************/

/* from defs.h */
#ifndef DOUB
#define DOUBLE float
#define ADOUBLE double
    /* ADOUBLE is used to reflect promotion in ansi prototypes */
#define INT int
#else
#define DOUBLE double
#define ADOUBLE double
#define INT int 
#endif

#if (USE_ARG_PROTOTYPES ) || __cplusplus || __STDC__
#define ARGS(list) list
#else
#define ARGS(list) ()
#endif

#define N_SUBBANDS 32  		/* number of analysis filters or subbands */
#define NP	1024  		/* FFT size */

/* from types.h */
typedef struct _tntstruct {
    INT tindx;   /* sparse table value index */
    DOUBLE spl;  /* sound pressure level */
    INT flag;     /* 1 => tonal, 0 => non tonal */
    } tntstrct;

/* sparse table used for display of peaks found */
typedef struct{
	INT fft_indx;	/* fft bin index */
	DOUBLE bark;	/* bark value */
	DOUBLE h_thld;   /* hearing threshold */
} ststrct;	/* sparse table definition structure */

/* fns in db.psyac.c */
extern void psyLegend PARG((int x, int y));
extern void psyDisp PARG((Rect *prec, short *stt, short *end, 
			  int chans, FRQVIEW *frqv));



