/*******************************************************************\
*																	*
*	db.tewin.c														*
*																	*	
*	TE window functions for DSPbench								*
*																	*
*	29mar90	dpwe													*
*																	*
\*******************************************************************/

#include "DSPbench.h"


AdjustText (wrcd)
	WINRCD	**wrcd;
	{
	int		oldScroll, newScroll, delta;
	
	oldScroll = (**(*wrcd)->w.te.TEH).viewRect.top - (**(*wrcd)->w.te.TEH).destRect.top;
	newScroll = GetCtlValue((*wrcd)->w.te.vScroll) * (**(*wrcd)->w.te.TEH).lineHeight;
	delta = oldScroll - newScroll;
	if (delta != 0)
		TEScroll(0, delta, (*wrcd)->w.te.TEH);
	}


SetVScroll(wrcd)
	WINRCD	**wrcd;
	{
	register int	n;
	
	n = (**(*wrcd)->w.te.TEH).nLines-(*wrcd)->w.te.linesInFolder;

	if ((**(*wrcd)->w.te.TEH).teLength > 0 
			&& (*((**(*wrcd)->w.te.TEH).hText))[(**(*wrcd)->w.te.TEH).teLength-1]=='\r')
		n++;

	SetCtlMax((*wrcd)->w.te.vScroll, n > 0 ? n : 0);
	}

ShowSelect(wrcd)
	WINRCD	**wrcd;
	{
	register	int		topLine, bottomLine, theLine;
	
	SetVScroll(wrcd);
	AdjustText(wrcd);
	
	topLine = GetCtlValue((*wrcd)->w.te.vScroll);
	bottomLine = topLine + (*wrcd)->w.te.linesInFolder;
	
	if ((**(*wrcd)->w.te.TEH).selStart < (**(*wrcd)->w.te.TEH).lineStarts[topLine] ||
			(**(*wrcd)->w.te.TEH).selStart >= (**(*wrcd)->w.te.TEH).lineStarts[bottomLine]) {
		for (theLine = 0; (**(*wrcd)->w.te.TEH).selStart >= (**(*wrcd)->w.te.TEH).lineStarts[theLine];
				 theLine++)
			;
		SetCtlValue((*wrcd)->w.te.vScroll, theLine - (*wrcd)->w.te.linesInFolder / 2);
		AdjustText(wrcd);
		}
	}

SetView(wrcd)
	WINRCD	**wrcd;
	{
	WindowPtr w = (*wrcd)->myWindow;

	HLock((Handle)wrcd);
	(**(*wrcd)->w.te.TEH).viewRect = w->portRect;
	(**(*wrcd)->w.te.TEH).viewRect.right -= SBarWidth;
	(**(*wrcd)->w.te.TEH).viewRect.bottom -= SBarWidth;
	InsetRect(&(**(*wrcd)->w.te.TEH).viewRect, 4, 4);
	(*wrcd)->w.te.linesInFolder = ((**(*wrcd)->w.te.TEH).viewRect.bottom-(**(*wrcd)->w.te.TEH).viewRect.top)
									/(**(*wrcd)->w.te.TEH).lineHeight;
	(**(*wrcd)->w.te.TEH).viewRect.bottom = (**(*wrcd)->w.te.TEH).viewRect.top 
						+ (**(*wrcd)->w.te.TEH).lineHeight*(*wrcd)->w.te.linesInFolder;
	(**(*wrcd)->w.te.TEH).destRect.right = (**(*wrcd)->w.te.TEH).viewRect.right;
	TECalText((*wrcd)->w.te.TEH);
	HUnlock((Handle)wrcd);
	}

pascal void teVScrollProc(theControl, theCode)
	ControlHandle	theControl;
	int				theCode;
	{
	int	pageSize;
	int	scrollAmt;
	
	if (theCode == 0)
		return ;
	
	pageSize = ((**(*frntWin)->w.te.TEH).viewRect.bottom-(**(*frntWin)->w.te.TEH).viewRect.top) / 
			(**(*frntWin)->w.te.TEH).lineHeight - 1;
			
	switch (theCode)
		{
		case inUpButton: 
			scrollAmt = -1;
			break;
		case inDownButton: 
			scrollAmt = 1;
			break;
		case inPageUp: 
			scrollAmt = -pageSize;
			break;
		case inPageDown: 
			scrollAmt = pageSize;
			break;
		}
	SetCtlValue( theControl, GetCtlValue(theControl)+scrollAmt );
	AdjustText(frntWin);
	}

ClickInTE(wrcd, theEvent)
	WINRCD		**wrcd;
	EventRecord	*theEvent;
	{
	ControlHandle 	theControl;
	int				cntlCode;
	int				pageSize;

	if ((cntlCode = FindControl(theEvent->where, (*wrcd)->myWindow, &theControl)) == 0)
		{
		if (PtInRect( theEvent->where, &(**(*wrcd)->w.te.TEH).viewRect ))
			TEClick( theEvent->where, (theEvent->modifiers & shiftKey )!=0, (*wrcd)->w.te.TEH);
		}
	else if (cntlCode == inThumb)
		{
		TrackControl(theControl, theEvent->where, 0L);
		AdjustText(wrcd);
		}
	else
		TrackControl(theControl, theEvent->where, &teVScrollProc);
	}

GrowTEwin(wrcd, p)
	WINRCD	**wrcd;
	Point p;
	{
	WindowPtr w = (*wrcd)->myWindow;
	int		oScroll;
	Rect 	r, oView;

	InvalRect(&w->portRect);
	oView = (**(*wrcd)->w.te.TEH).viewRect;
	oScroll = GetCtlValue((*wrcd)->w.te.vScroll);
	
	SetView(wrcd);
	HidePen();
	MoveControl((*wrcd)->w.te.vScroll, w->portRect.right - SBarWidth, w->portRect.top-1);
	SizeControl((*wrcd)->w.te.vScroll, SBarWidth+1, w->portRect.bottom - w->portRect.top-(SBarWidth-2));
	ShowPen();

	SetVScroll(wrcd);
	AdjustText(wrcd);
	}

NewTEwin(wrcd)
	WINRCD	**wrcd;
	{
	Rect	vScrollRect;
	Rect	destRect, viewRect;		/* only using viewRect at present */

	SetPort((*wrcd)->myWindow );
	TextFont(4);
	TextSize(9);
	vScrollRect = ((*wrcd)->myWindow)->portRect;
	vScrollRect.left = vScrollRect.right-15;
	vScrollRect.right += 1;	vScrollRect.bottom -= 14;	vScrollRect.top -= 1;
	(*wrcd)->w.te.vScroll = NewControl( (*wrcd)->myWindow, &vScrollRect, "\p", 1, 0, 0, 0,
		scrollBarProc, 0L);

	viewRect = thePort->portRect;
	viewRect.right -= SBarWidth;	viewRect.bottom -= SBarWidth;
	InsetRect(&viewRect, 4, 4);
	(*wrcd)->w.te.TEH = TENew( &viewRect, &viewRect );
	SetView(wrcd);
	}

int ReadTEfile( wrcd, fn )
	WINRCD	**wrcd;
	Str255	fn;
	{
	short	refNum;
	TEHandle textH = (*wrcd)->w.te.TEH;
	char	buffer[256];
	long	count;
	int		io = noErr;
	int 	vRef,err = 0;
	
	vRef = (*wrcd)->theVRefNum;
	if (FSOpen(fn, vRef, &refNum)==noErr)
		{
	TESetSelect(0, (**textH).teLength, textH);
	TEDelete( textH );
	do	{
		count = 256;
		io = FSRead( refNum, &count, &buffer );
		TEInsert( &buffer, count, textH );
		} while (io==noErr);
		FSClose(refNum);
		}
	else
		err = 1;
	if(err)
		FileError( "\pError Opening ", fn );
	return( io!=eofErr );
	}

