/*******************************************************************\
*																	*
*	db.windows.c													*
*																	*	
*	windows functions for DSPbench									*
*																	*
*	29mar90	dpwe													*
*																	*	
\*******************************************************************/

#include "DSPbench.h"

/* globals */
Handle	leftArrowIcon,rightArrowIcon,upArrowIcon,downArrowIcon;

/* prototypes */

SetUpWindows()		/* ? */
	{
	Str255	name;
	
	leftArrowIcon = GetResource('ICN#',256);
	rightArrowIcon = GetResource('ICN#',257);
	upArrowIcon = GetResource('ICN#',258);
	downArrowIcon = GetResource('ICN#',259);
	
	pStrCopy("\pdebug",(char *)name);
	dbugWin = winRoot = MyNewWindow(winRoot,name,TEWin);	

	}

WINRCD **MyNewWindow(nxtWrcdH, wName, wType)
	WINRCD	**nxtWrcdH;			/* allow preset into linked list */
	Str255	wName;				/* name to give window */
	int 	wType;				/* what sort of window to create ? */
	{
	FontInfo	myInfo;
	int		height;
	WINRCD	**rslt;
	int		wid;

	wid = DefWdwID(wType);		/* get default window resource id */
	rslt = (WINRCD **)NewHandle(sizeof(WINRCD));
	HLock((Handle)rslt);
	(*rslt)->myWindow = GetNewWindow( wid, NULL, (WindowPtr)-1L );
	if( (*rslt)->myWindow == NULL)		/* No more windows ! */
		{
		HUnlock((Handle)rslt);
		DisposHandle((Handle)rslt);
		/* Notify problem ... ? */
		return(NULL);					/* but remember, typically written straight into root! */
		}
	pStrCopy(wName, (char *)(*rslt)->theFileName);
	SetWTitle( (*rslt)->myWindow, wName );

	(*rslt)->winType = wType;			/* for want of something else */

	NewWind(rslt);						/* type specific initialisation */

	(*rslt)->dirty = 0;
	(*rslt)->nextHan = nxtWrcdH;
	(*rslt)->dragRect.top = 0;(*rslt)->dragRect.left = 0;
	(*rslt)->dragRect.bottom = 1024;(*rslt)->dragRect.right = 1024 ;
	(*rslt)->theVRefNum = 0;
	HUnlock((Handle)rslt);
	frntWin = rslt;
	return(rslt);
	}

UpdateWindow(wrcd)
	WINRCD	**wrcd;
	{
	WindowPtr	theWindow = (*wrcd)->myWindow;
	GrafPtr	savePort;
	
	GetPort( &savePort );
	SetPort( theWindow );
 	BeginUpdate( theWindow );	
	EndUpdate( theWindow );		
/*	begin/end update just prevent redrawing undirtied part of wdw 
 	- but we must redraw it, since it changes on a size change */

	EraseRect(&theWindow->portRect);
	DrawControls( theWindow );
	UpdateWin(wrcd);			/* dispatches to TEUpdate or whatever */
	DrawGrowIcon( theWindow );
	SetPort( savePort );
	}




DoClickInConts(wrcd, theEvent)
	WINRCD		**wrcd;
	EventRecord	*theEvent;
	{
	WindowPtr		theWindow = (*wrcd)->myWindow;
	GrafPtr			savePort;
	
	GetPort(&savePort);
	SetPort(theWindow);
	GlobalToLocal( &theEvent->where );

	ClickInWin(wrcd, theEvent);		/* pass to appropriate window type */

	SetPort(savePort);
	}

MyGrowWindow( wrcd, p )
	WINRCD	**wrcd;
	Point p;
	{
	WindowPtr w = (*wrcd)->myWindow;
	GrafPtr	savePort;
	long	theResult;
	Rect	r;
	
	GetPort( &savePort );
	SetPort( w );

	SetRect(&r, 80, 80, screenBits.bounds.right, screenBits.bounds.bottom);
	theResult = GrowWindow( w, p, &r );
	if (theResult == 0)
		return;
	SizeWindow( w, LoWord(theResult), HiWord(theResult), 1);

	GrowWin(wrcd,p);

	SetPort( savePort );
	}

MyCloseWindow(wrcd)			/* close this window by finding its parent */
	WINRCD	**wrcd;
	{
	WINRCD	***pparent;		/* pointer to a window record handle */
	int 	done = false;
	WINRCD	**lock = NULL;

	pparent = &winRoot;
	while( (!done) &&( (*pparent) != NULL) )
		{
		if((*pparent) == wrcd)
			{
			DoCloseWin(pparent);
			done = true;
			}
		else{
			if(lock)
				HUnlock((Handle)lock);
			HLock((Handle)(lock = *pparent));
			pparent = &(*lock)->nextHan;
			}
		}
	if(lock)
		HUnlock((Handle)lock);
	}

DoCloseWin(pparent)		/* close the NEXT FIELD of the specified window & close up gap */
WINRCD ***pparent;
	{
	WINRCD **wrcd = *pparent;

	CloseWin(*pparent);				/* window - specific closing */
	DisposeWindow( (*wrcd)->myWindow );
	(*pparent) = (*wrcd)->nextHan;	/* close gap */
	DisposHandle( (Handle)wrcd );
	}

