/*****************************************************/
/* db.xmain.c                                        */
/* Set up X display etc for dspBench                 */
/* dpwe 30apr90                                      */
/*****************************************************/

#include <stdio.h>
#include <strings.h>
#include <math.h>		/* for atof() in HandleArgs() */
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/cursorfont.h>	/* for cursor font defs */
#include "DSPbench.h"

#include <wndw.h>		/* an abstracted X interface (hmm) */

#include "bitmaps/gray"
#include "bitmaps/ltgray"
#include "bitmaps/uarrow"
#include "bitmaps/darrow"
#include "bitmaps/larrow"
#include "bitmaps/rarrow"
#include "bitmaps/dspB_icon"
#include "bitmaps/tick"

/* Manifests */
#define WIN_X 40
#define WIN_Y 40
#define WIN_W 750 /* 1000 */
#define WIN_H 525 /* 330 */
#define BORD_W 1

/* for gray scale definitions */
#define GRAYBITS	6
#define GRAYS   (1<<GRAYBITS)
#define GSCALEUP (1<<(8-GRAYBITS)) /* such that GRAYS*GSCALEUP = 256 */
#define H_RED	256	/* default hue for spectrogram */
#define H_GREEN	256
#define H_BLUE	256

#ifdef sun
#define strchr(a,b)   index(a,b)
#define strrchr(a,b)  rindex(a,b)
#endif /* sun */

/* Externs */
extern short ulaw_decode[]; 	/* in ulaw.c */

/* static fn prototypes */
#ifdef __STDC__
static unsigned long *def_gray(Display *disp, int screen, 
			       int red, int green, int blue);
#else
static unsigned long *def_gray();
#endif

/* Globals */
Display 			*disp;
int     			scrnNum;
Window  			theWin;
XWindowAttributes 		wAttribs;
GC      			gc;
Pixmap  			grayPM;
Pixmap  			ltGrayPM;
Pixmap  			leftArrowIcon;
Pixmap  			rightArrowIcon;
Pixmap  			upArrowIcon;
Pixmap  			downArrowIcon;
Pixmap				tickIcon;
Cursor				arrow;
Cursor				waitCursor;
Cursor				xCursor;
Cursor				pauseCursor;
char				*programName;
int				err = 0;
char 				*fontname = "fixed";
int				dfltX = WIN_W;
int				dfltY = WIN_H;

WINRCD				**wrcd;
int             		done = 0;	/* flag set anywhere kills */

static int 	graycolors = 0;		/* allocate coloured graymap? */
static int 	bicolore   = 0;		/* only use black and white? */

int directopen = 0;			/* flag to open as spectrogram */

unsigned long 	*colrs;
int		grays;

int		forceChans = 0;
double		minTrackDB = -50.0;	
/* minimum peak mag of tracks to display - see db.peaks.c */

static int EventHandler(XEvent *theEv, void *data);

main(argc,argv)
    int     argc;
    char    **argv;
    {
#ifdef MIPS
    stp_flt_handl();		/* DEC-furnished non-IEEE exception traps */
#endif
    HandleArgs(argc,argv);
    MyXInit((*wrcd)->theFileName, argc, argv);
    (*wrcd)->myWindow = theWin;
/* #ifdef DEBUGGRAPHS */
    /* ALWAYS use wndw's XEvent loop now - so must ALWAYS initialize it */
    /* make sure our event loop handler will be installed if using dbgGrs */
/*    gdSetXdisp(disp);	/* pre-empt X opening */
    WSetXdisp(disp);
    WInitX();
/*    gdInstallEventHandler(EventHandler, (void *)wrcd);	*/
    WAddEventHandler(NULL, EventHandler, (void *)wrcd);
/* #endif /* DEBUGGRAPHS */
    EventLoop();
    MyXClose();
#ifdef MIPS
    rls_flt_handl();			/* undo wacko fpe traps */
#endif
    exit(0);
    }

int MakeOurStruc(name)
    char *name;
    {
    wrcd = (WINRCD **)NewHandle(sizeof(WINRCD));
    (*wrcd)->myWindow = theWin;
    strcpy((char *)(*wrcd)->theFileName,name);
    NewTGwin(wrcd);
    return ReadTGfile(wrcd, name);
    }

#define TMPDIR "/tmp"
#define TMPSND "tmp"	/* extension is added per sndf */

/* 
/* PlaySelSnd(wrcd)
/*     WINRCD **wrcd;
/*     {
/*     long   outBSize;
/*     int    format = SFMT_SHORT;
/*     int    rate = (*wrcd)->w.tg.sRate;
/*     int    outChans= (*wrcd)->w.tg.chans;
/*     long   sBeg   = (*wrcd)->w.tg.sBstt;
/*     long   sEnd   = (*wrcd)->w.tg.sBend;
/*     SFSTRUCT *tmpSound, *inSound = (SFSTRUCT *)*((*wrcd)->w.tg.soundHan);
/*     short  *ptr1,*ptr2,*ptr3;
/* 
/*     printf("play sel snd..\n");
/*     outBSize = sEnd-sBeg;
/*     if(outBSize > 0)
/* 	{
/* 	if(err = SFAlloc(&tmpSound,outBSize,format,rate,outChans,4))
/*	    {
/*	    fprintf(stderr,"%s: sound error %s\n", programName,
/*	            SFErrMsg(err));
/*	    exit(1);
/*	    }
/* 	ptr1 = (short *)SFDataLoc(tmpSound);
/* 	ptr2 = (short *)SFDataLoc(inSound);
/* 	ptr3 = (short *)(((char *)ptr2)+sEnd);
/* 	ptr2 = (short *)(((char *)ptr2)+sBeg);
/* 	while(ptr2<ptr3)
/* 	    *ptr1++ = *ptr2++;
/* 	if(err = SFWrite(TMPSND, tmpSound))
/* 	    soundErrorExit();
/* 	system("vaxify -h /tmp/tmp.irc /tmp/tmpvsnd; rcp /tmp/tmpvsnd ems:/u/sound/$USER/tmpsnd; rsh ems play tmpsnd > /dev/null");
/* 	SFFree(tmpSound);
/* 	}
/*     }
 */

#ifndef LOFI
#ifndef TCPPLAY
play(stt,end,chans,dsize,srate,scale)	/* called from main place */
    short   *stt;
    short   *end;
    int     chans;
    int     dsize;    /* ignored - assumed = sizeof(short) in what follows */
    double  srate;    /***** NO RESAMPLING if != 8000 Hz - just wrong pitch */
    int     scale;    /* crude integer scale factor; 2 => no scaling */
    {
#ifdef DEVAUDIO
    muplay(stt,end,chans,dsize,srate,scale);	/* pass to resampling */
#endif /* DEVAUDIO */
    }
#endif /* TCPPLAY */
#endif /* LOFI */

#ifdef DEVAUDIO		/* audio output via /dev/audio */

#define SBLKSIZ 4096	/* how many bytes written to /dev/audio at once */

#define MUCLIP  32635
#define BIAS    0x84
#define MUZERO  0x02
#define ZEROTRAP

noRSplay(stt,end,chans,dsize,srate,scale)	/* WAS the mulaw play */
    short   *stt;
    short   *end;
    int     chans;
    int     dsize;    /* ignored - assumed = sizeof(short) in what follows */
    double  srate;    /***** NO RESAMPLING if != 8000 Hz - just wrong pitch */
    int     scale;    /* crude integer scale factor; 2 => no scaling */
    {
    long	outBSize,outBRem;
    int 	format;
    int 	c;
    long	d;
    short	*ptr1;
    unsigned char	*ptr2;
    SFSTRUCT	*tmpSound;
    long	nblocks;
    int 	thisBlSiz;
    FILE	*op;
    register int    sign;
    int sample, exponent, mantissa, ulawbyte;
    extern  char    exp_lut[];	/* mulaw encoding table */

    outBSize = (((long)(end-stt))*sizeof(char))/(long)chans;
    /* assu short *stt etc, o/p bytes */
    format = SFMT_ULAW;
/*    fprintf(stderr,"Allocate %ld bytes, format %d, srat %ld\n",outBSize,
	format, (long)srate);	/* */
    if(err = SFAlloc(&tmpSound,outBSize,format,srate,1,4))
	{
	fprintf(stderr,"%s: sound error %s\n", programName, 
		SFErrMsg(err));
	exit(1);
	}
    ptr1 = stt;
    ptr2 = (unsigned char *)SFDataLoc(tmpSound);
    while(ptr1<end)		/* copy whole to a new byte mulaw sound */
	{
	d = 0L;
	for(c = 0; c<chans; ++c) /* average over all channels */
	    d += *ptr1++;
	d *= scale;		/* apply scale factor .. */
	d /= 2L*(long)chans;	/* and correct for multi chans */
	/* mulaw mapping from SFtouB HERE */
	if (d < 0) {		/* if sample negative	*/
	    sign = 0x80;
	    d = -d;		/*  make abs, save sign	*/
	    }
	else sign = 0;
	if (d > MUCLIP)		/* out of range? */
	    d = MUCLIP;		/*   clip	 */
	sample = d + BIAS;
	exponent = exp_lut[( sample >> 8 ) & 0x7F];
	mantissa = ( sample >> (exponent+3) ) & 0x0F;
	ulawbyte = ~ (sign | (exponent << 4) | mantissa );
#ifdef ZEROTRAP
	if (ulawbyte == 0) ulawbyte = MUZERO; /* optional CCITT trap */
#endif	
	*ptr2++ = ulawbyte;
	}
    if( (op = fopen("/dev/audio","w")) != NULL)
	{
	nblocks = (outBSize + SBLKSIZ - 1)/SBLKSIZ;
	outBRem = outBSize;
	ptr2 = (unsigned char *)SFDataLoc(tmpSound);
	while(nblocks--)	/* copy output bytes to /dev/audio */
	    {
	    thisBlSiz = outBRem;
	    if(thisBlSiz > SBLKSIZ)		thisBlSiz = SBLKSIZ;
	    fwrite(ptr2,sizeof(char),thisBlSiz,op);
	    outBRem -= thisBlSiz;
	    ptr2 += thisBlSiz;
	    }
	fclose(op);		/* flush output */
	}
    else{
	fprintf(stderr,"/dev/audio busy\007\n");
	}
    SFFree(tmpSound);
    }

record(stt,end,chans,dsize,srate,scale)	/* called from main place */
    short   *stt;
    short   *end;
    int     chans;
    int     dsize;    /* ignored - assumed = sizeof(short) in what follows */
    double  srate;    /***** NO RESAMPLING if != 8000 Hz - just wrong pitch */
    int     scale;    /* crude integer scale factor; 2 => no scaling */
    {
    fprintf(stderr,"No record on SMORG - sorry\n");
    }

#endif /* def SMORG */
xtract(stt,end,chans,dsize,srate,scale)	/* called from main place */
    short   *stt;
    short   *end;
    int     chans;
    int     dsize;    /* ignored - assumed = sizeof(short) in what follows */
    double  srate;
    int     scale;    /* crude integer scale factor; 2 => no scaling */
    {
    long	outBSize,outBRem;
    int 	format;
    int 	c;
    long	d;
    short	*ptr1;
    short	*ptr2;
    SFSTRUCT	*tmpSound;
    long	nblocks;
    int 	thisBlSiz;
    FILE	*op;
    char 	tmpSndName[80];

    sprintf(tmpSndName, "%s/%s%s", TMPDIR, TMPSND, sndfExtn);
    outBSize = (((long)(end-stt))*sizeof(short));
    /* assu short *stt etc, o/p short */
    format = SFMT_SHORT;
    /*	printf("Allocate %ld bytes, format %d, srat %ld\n",outBSize,
	format, (long)srate);	/*  */
    if(err = SFAlloc(&tmpSound, outBSize, format, srate, chans, 4))
	{
	fprintf(stderr,"%s: sound error %s\n", programName,
		SFErrMsg(err));
	exit(1);
	}
    ptr1 = stt;
    ptr2 = (short *)SFDataLoc(tmpSound);
    while(ptr1<end)		/* copy whole to a new byte mulaw sound */
	{
	*ptr2++ = *ptr1++;
	}
    if(err = SFWrite(tmpSndName, tmpSound))
	{
	fprintf(stderr,"%s: sound error %s\n", programName,
		SFErrMsg(err));
	exit(1);
	}
    printf("region extracted to %s (%ld bytes)\n",
	   tmpSndName, outBSize);
    SFFree(tmpSound);
    }

HandleArgs(argc,argv)
    int     argc;
    char    **argv;
    {
    char    	*inputSoundFile = NULL;
    int 	i = 1;
    int 	err = 0;

    programName = argv[0];
    while(i<argc)
	{
	if(argv[i][0] == '-')
	    {
	    if(argv[i][1] == 'c') {	/* -c n forces to n channels */
		forceChans = atoi(argv[++i]);
		if(forceChans <= 0)	err = 1;
		}
	    if(argv[i][1] == 'm')	/* -m n sets min track lvl */
		minTrackDB = atof(argv[++i]);
	    if(argv[i][1] == 'f')	/* -f name sets font */
		fontname = argv[++i];
	    if(argv[i][1] == 's')  {	/* -s x y sets size */
		dfltX = atoi(argv[++i]);
		dfltY = atoi(argv[++i]);
		}
	    if(argv[i][1] == 'g')	/* -g selects gray colormap */
		graycolors = 1;
	    if(argv[i][1] == 'b')	/* -b selsects black&white */
		bicolore = 1;
	    if(argv[i][1] == 'x')	/* -x forces special display */
		directopen = 1;
	    }
	else
	    inputSoundFile = argv[i];
	++i;
	}
    if(err || inputSoundFile == NULL)
	{
	fprintf(stderr,
"usage: %s [-c #chs][-m minTrackDB][-f font][-s w h][-g|-b] soundfile\n",
		argv[0]);
	exit(0);
	}
    /* Read sound file */
    if (err = MakeOurStruc(inputSoundFile) )
	SFDie(err, inputSoundFile);
    /* Abort if unsupported format */
/*  if ( ((*wrcd)->w.snd.snd)->format != SFMT_SHORT)
        {
	fprintf(stderr, "%s: unsupported sound format: %d\n",
	        programName, inputSound->format);
	exit(1);
        }
 */
    }

#define MYX_ANY_EVENT (-1L)

static int EventHandler(XEvent *theEv, void *data)
{	/* externally installable event handler */
    WINRCD 	**wrcd = (WINRCD **)data;    
    Window	theWin = (*wrcd)->myWindow;
    Rect   	exRect;

    if(theEv->xany.window == theWin)  {
	switch(theEv->type)  {
	case ButtonPress:
	    ClickInTG(wrcd, theEv);
	    break;
	case ButtonRelease:
	    /* ignore for now */
	    break;
	case Expose:
	    /* can't ignore multiple exposes since not redrawing whole 
	       screen.  But if more than one of the expose rects intersect 
	       a given screen fn, will redraw it more than once.  Should 
	       really cumulate them into a region, then redraw each pane 
	       based on intersection with that, at most once - 
	       see src/motif/filelist   1992oct28 */
	    if(1 || theEv->xexpose.count==0)	{
		/* two exposes after resize - must fix 25sep91 */
		exRect.left = theEv->xexpose.x; exRect.top = theEv->xexpose.y;
		exRect.right = exRect.left + theEv->xexpose.width;
		exRect.bottom = exRect.top + theEv->xexpose.height;
		DrawWin(theWin, &exRect);
	    }
	    break;
	case MotionNotify:
	    MoveInTG(wrcd, theEv);
	    break;
	case NoExpose:
	    /* why are we getting these?  What are they? */
	    break;
	case ClientMessage:
	    /* why are we getting THESE? from mwm, it seems */
	    break;
	default:
	    fprintf(stderr, "unrec event %d in dspB win\n", theEv->type);
	    break;
	}
	return 1;	/* we handled it */
    }
    else
	return 0;	/* unrec event (not our window) */
}

EventLoop()
{
    XEvent theEv;

    while(!done)  {
/*	XWindowEvent(disp, theWin, MYX_ANY_EVENT, &theEv);
	EventHandler(&theEv, (void *)wrcd);	*/
	WEventLoop();	/* let wndw handle it all now .. */
	UpdateTime();	/* maybe rewrite date & time in menu bar */
    }
}

oldEventLoop()
    {
    XEvent theEv;
/*    int	   done = 0; */
    Rect   exRect;

    while(!done)
	{
/*	XNextEvent(disp, &theEv);
	switch(theEv.type)
	    {
	case ButtonPress:
	    ClickInTG(wrcd, &theEv);
	    break;
	case Expose:
	    if(theEv.xexpose.count==0)
		{
		exRect.left = theEv.xexpose.x; exRect.top = theEv.xexpose.y;
		exRect.right = exRect.left + theEv.xexpose.width;
		exRect.bottom = exRect.top + theEv.xexpose.height;
		DrawWin(theWin, &exRect);
		}
	    break;
	case MotionNotify:
	    MoveInTG(wrcd, &theEv);
	    break;
	default:
	    break;
	    }
 */
	WEventLoop();	/* let wndw handle it all now .. */
	UpdateTime();	/* maybe rewrite date & time in menu bar */
	}
    }

DrawWin(win, prect)
    Window win;
    Rect *prect;
    {
    Point   dummy;

/*    printf("Drw: win is %lx\n",(long)win);	*/

    /* Lets hope it's the right one */
/*    GrowTGwin(wrcd,dummy);	/* registers size */
    /* SetTGwin inside TGupdate */
    TGupdate(wrcd, prect);
    }

OldDrawWin(win)
    Window win;
    {
    int    x,y,w,h;
    XSegment lseg;

    printf("OldDrw: win is %lx\n",(long)win);
    XGetWindowAttributes(disp,win,&wAttribs);
    x = 0;  y = 0;  w = wAttribs.width;  h = wAttribs.height;
    lseg.x1 = x;   lseg.y1 = y;
    lseg.x2 = x+w; lseg.y2 = y+h;
    XDrawLine(disp, win, gc, x, y, x+w, y+h);
    XDrawLine(disp, win, gc, x, y+h, x+w, y);
    }

typedef struct {	/* one anchor point in RGB space */
    int red;
    int green;
    int blue;
} RGB_TRIPLE;

static int SetColorCells(Display *display, int screen, 
			 unsigned long gray[], int grays, 
			 RGB_TRIPLE *rgb1, RGB_TRIPLE *rgb2)
{	/* fill in a range of color cells linearly between rgb pairs */
    Colormap color_map;
    XColor exact_def,col_def;

    unsigned long plane_masks[1];
    unsigned long i;
    long	su = 256/grays;
    int 	r0, g0, b0;
    int 	dr, dg, db;

    r0 = rgb1->red   << 8;	dr = rgb2->red   - rgb1->red;	
    g0 = rgb1->green << 8;	dg = rgb2->green - rgb1->green;	
    b0 = rgb1->blue  << 8;	db = rgb2->blue  - rgb1->blue;	

    color_map = DefaultColormap(display, screen);
    if(XAllocColorCells(display,color_map,	
			False,plane_masks,0,gray,grays)==0) {
	fprintf(stderr,"SetColorCells fail (XAllocColorCells)\n");
	exit(1);
    }
    else {
	for(i=0; i<grays; ++i)  {
	    col_def.pixel = gray[i];
	    col_def.red =   r0+(dr*i*su);
	    col_def.green = g0+(dg*i*su);
	    col_def.blue =  b0+(db*i*su);
	    col_def.flags = 7;
	    XStoreColor(display,color_map,&col_def);
	}
    }
    XFlush(display);
    return 1;
}

typedef struct {	/* an anchor point plus how many steps before next */
    RGB_TRIPLE 	rgb;
    int		npts;
} RGB_SEGMENT;

#ifndef PALE_COLORS
#define RGB_POINTS	5
RGB_SEGMENT xrgb_table[RGB_POINTS + 1] = 
{  { {   0,   0,   0 }, 16 },
   { {  32,  16, 192 }, 8 }, 
   { { 128,  32, 144 }, 8 }, 
   { { 192,  32,  64 }, 16 }, 
   { { 255, 208,  64 }, 16 },
   { { 255, 255, 255 }, 0 } };
#else /* PALE_COLORS */
#define RGB_POINTS	5
RGB_SEGMENT xrgb_table[RGB_POINTS + 1] = 
{  { {  64,  64,  64 }, 16 },
   { {  96,  80, 220 }, 8 }, 
   { { 180,  96, 180 }, 8 }, 
   { { 222,  96, 140 }, 16 }, 
   { { 255, 222, 140 }, 16 },
   { { 255, 255, 255 }, 0 } };
#endif /* PALE_COLORS */

#define NRGB_POINTS	6
RGB_SEGMENT nrgb_table[NRGB_POINTS + 1] = 
{  { {  16,  16,  16 }, 8 },
   { {  16,  16, 144 }, 8 }, 
   { { 128,  16, 192 }, 4 }, 
   { { 192,  16, 144 }, 4 }, 
   { { 255,  16,  16 }, 8 }, 
   { { 255, 192,  32 }, 16 }, 
   { { 255, 255, 192 }, 0 } };


#define BW_POINTS	1
RGB_SEGMENT xbw_table[BW_POINTS + 1] = 
{  { { 255, 255, 255 }, 32 }, 
   { {   0,   0,   0 }, 0 } };

/*
#define RGB_POINTS	4	/* how many line segments in our table * /
RGB_SEGMENT xrgb_table[RGB_POINTS + 1] = 
{  { {   0,   0,   0 }, 8 }, 
   { {  32,  32, 255 }, 8 }, 
   { {  32, 128,  32 }, 8 }, 
   { { 220, 200,  96 }, 8 },
   { { 255, 255, 192 }, 0 } };	/* N+1 points for N segs * /   
 */

static unsigned long *def_gray(display,screen,red,green,blue)
    Display *display; 
    int screen,red,green,blue;
{	/* do colormap setup via wndw.c - allows psoutput to use it too */
    unsigned long *pixels;

    if(WInitColormap(graycolors, bicolore)==0)  {
	fprintf(stderr, "no colormap - using B+W\n");
	if(WInitColormap(1, 1)==0)  {
	    fprintf(stderr, "no colormap at all!\n");
	    return NULL;
	}
    }
    WGetPixelTable(&pixels, &grays);
    return pixels;
}

static unsigned long *good_def_gray(display,screen,red,green,blue)
    Display *display; 
    int screen,red,green,blue;
{	/* was def_gray prior to new one that uses WInitColormap */
    static unsigned long ucolors[GRAYS];
    int	   depth, i;
    RGB_SEGMENT *table;
    int	   tabsize;

    if(graycolors)  {	/* monochrome (grayscale) colormap */
	table = xbw_table;
	tabsize = BW_POINTS;
    } else {
	table = xrgb_table;
	tabsize = RGB_POINTS;
    }

    depth = DisplayPlanes(display,screen);
    /* <bicolore> is command line '-b' flag to use just 2 colors */
    if(bicolore || depth < 3)	/* less than eight colours - use B&W */
	{
	grays = 2;
	ucolors[0] = XBlackPixel(display,screen);
	ucolors[1] = XWhitePixel(display,screen);
	return(ucolors);
	}
    else
	{
	grays = 1<<(depth - 1);		/* up to half of the avai grays.. */
	if(grays > GRAYS)	grays = GRAYS;	/* but at most GRAYS */
/*	SetColorCells(display, screen, ucolors, grays, 
		      0, 0, 0, red, green, blue);    */
/*	fprintf(stderr, "black: %d %d %d\n", table[0].rgb.red, table[0].rgb.green, table[0].rgb.blue);
 */
	/* try a funky color map */
	grays = 0;
	for(i = 0; i<tabsize; ++i)  {
	    SetColorCells(display, screen, &ucolors[grays], table[i].npts, 
			  &table[i].rgb, &table[i+1].rgb);
	    grays += table[i].npts;
	} 
	return ucolors;
    }
}
    
static unsigned long *old_def_gray(display,screen,red,green,blue)
    Display *display; 
    int screen,red,green,blue;
    {
    Colormap color_map;
    XColor exact_def,col_def;

    unsigned long plane_masks[1];
    unsigned long i;
    static unsigned long ucolors[GRAYS];
    int depth;
    long scaleup;

    depth = DisplayPlanes(display,screen);
    if(depth < 3)	/* less than eight colours - use B&W */
	{
	grays = 2;
	ucolors[0] = XBlackPixel(display,screen);
	ucolors[1] = XWhitePixel(display,screen);
	return(ucolors);
	}
    else
	{
	grays = 1<<(depth - 1);		/* up to half of the avai grays.. */
	if(grays > GRAYS)	grays = GRAYS;	/* but at most GRAYS */
	scaleup = 256L/grays;
	color_map = DefaultColormap(display, screen);
	if(XAllocColorCells(display,color_map,	
			False,plane_masks,0,ucolors,grays)==0)	
	    {
	    printf("DEF COLOR FAULT (XAllocColorCells)\n");
	    grays = 2;	/* monochrome fallback */
	    ucolors[0] = XBlackPixel(display,screen);
	    ucolors[1] = XWhitePixel(display,screen);
	    return(ucolors);
	    }
	else
	    {
	    for(i=0; i<grays; i++)
		{
		col_def.pixel = ucolors[i];		
		col_def.red = (red*i)*scaleup;
		col_def.green = (green*i)*scaleup;
		col_def.blue = (blue*i)*scaleup;
		col_def.flags = 7;
		XStoreColor(display,color_map,&col_def);
		}
	    }
	XFlush(display);
/*    	printf("grays allocated OK\n");	*/
	return(ucolors);
	}
    }

#define HNMLEN 80

MyXInit(name, argc, argv)
    char *name;	/* filename for window title */
    int  argc;
    char **argv;
    {
    XSetWindowAttributes attribs;
    XGCValues            gcVals;
    unsigned long        amask;
    int x,y,w,h;
    char winName[80];
    char hostName[HNMLEN], *ppd;
    Pixmap pixm;

    disp = XOpenDisplay(NULL);
    if(disp==NULL)
	{
	fprintf(stderr, 
		"%s: Could not open X display - check DISPLAY variable\n",
		programName);
	exit(0);
	}
    scrnNum = XDefaultScreen(disp);
    attribs.background_pixel = XWhitePixel(disp,scrnNum);
    attribs.backing_store    = WhenMapped;
    attribs.event_mask	     = ButtonPressMask|ExposureMask
	                        |ButtonReleaseMask|ButtonMotionMask
				    | PointerMotionMask;
    amask   = CWBackPixel|CWBackingStore|CWEventMask;
    theWin  = XCreateWindow(disp, XDefaultRootWindow(disp),
			 WIN_X, WIN_Y, dfltX, dfltY, BORD_W, 
			 CopyFromParent, InputOutput, CopyFromParent, 
			 amask, &attribs);
/*    printf("MyXInit: win is %lx\n",(long)theWin);	*/
/*    strcpy(winName,"dspbench - ");	*/
    if( (ppd = strrchr(programName, '/'))==NULL)	ppd = programName;
    else ++ppd;	/* skip over the '/' */
    strcpy(winName, ppd);
    hostName[0] = '@';
    gethostname(hostName+1, HNMLEN-1);
    if(ppd = strchr(hostName, '.'))	*ppd = '\0';	/* cut off .* */
    strcat(winName, hostName);
    strcat(winName, " - ");
    strcat(winName, name);
/*    XStoreName(disp, theWin, winName);	*/
    pixm = XCreatePixmapFromBitmapData(disp, theWin,
		 dspB_icon_bits, dspB_icon_width, dspB_icon_height,
		 1,0,
		 1);
    XSetStandardProperties(disp, theWin, winName, name, pixm, argv, argc,
			   NULL);
    XMapWindow(disp,theWin);
    gcVals.function   = GXcopy;  
    gcVals.line_width = 0;
    gcVals.foreground = XBlackPixel(disp,scrnNum);
    gcVals.background = XWhitePixel(disp,scrnNum);
    gc = XCreateGC(disp, theWin, 
		   GCFunction|GCLineWidth|GCForeground|GCBackground, &gcVals);
/*    XReadBitmapFile(disp, theWin, "bitmaps/ltgray", &w,&h, &ltGrayPM, &x,&y);
    printf("Pixmap read %lx \n",(long)ltGrayPM); */
/*    ltGrayPM = (Pixmap)lgry;  w = 8; h = 8;	
    ltGrayPM = XCreatePixmapFromBitmapData(disp, theWin, ltGrayPM, w,h,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));	*/
    grayPM = XCreatePixmapFromBitmapData(disp, theWin,
		 gray_bits, gray_width, gray_height,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));
    ltGrayPM = XCreatePixmapFromBitmapData(disp, theWin,
		 ltgray_bits, ltgray_width, ltgray_height,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));

    upArrowIcon = XCreatePixmapFromBitmapData(disp, theWin,
		 uarrow_bits, uarrow_width, uarrow_height,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));
    downArrowIcon = XCreatePixmapFromBitmapData(disp, theWin,
		 darrow_bits, darrow_width, darrow_height,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));
    leftArrowIcon = XCreatePixmapFromBitmapData(disp, theWin,
		 larrow_bits, larrow_width, larrow_height,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));
    rightArrowIcon = XCreatePixmapFromBitmapData(disp, theWin,
		 rarrow_bits, rarrow_width, rarrow_height,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));
    tickIcon = XCreatePixmapFromBitmapData(disp, theWin,
		 tick_bits, tick_width, tick_height,
		 XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum), 
		 XDefaultDepth(disp,scrnNum));
    arrow = XCreateFontCursor(disp, XC_arrow);
    waitCursor = XCreateFontCursor(disp, XC_coffee_mug);
    xCursor= XCreateFontCursor(disp, XC_crosshair);
    pauseCursor = XCreateFontCursor(disp, XC_middlebutton);
    if((colrs = def_gray(disp,scrnNum,H_RED,H_GREEN,H_BLUE)) == NULL)
	{printf("def_gray error.\n"); exit(0);}

    InitX();	/* more stuff in macalike.c */
    }

MyXClose()
    {
    XUnmapWindow(disp,theWin);
    XDestroyWindow(disp,theWin);
    XCloseDisplay(disp);
    }


