/*******************************************************\
* macalike.c 						*
* Mac-support functions for port of DSPbench to X  	*
* dpwe 30apr90						*
\*******************************************************/

#ifdef THINK_C

/***************************************************************\
*	mac part													*
*	Provides the extra functions created in macalike.c for 		*
*	the x-window version on the macintosh						*
*	i.e. mostly simple covers									*
*	26jul90	dpwe												*
\***************************************************************/

#include "DSPbench.h"

PushClip(pold,new)
	RgnHandle	*pold;
	Rect		new;
	{
	*pold = (RgnHandle)NewHandle(sizeof(Region));
	GetClip(*pold);
/*	D_prints("PushClip: top "); D_printn(new.top);
	D_prints("         left "); D_printn(new.left);
	D_prints("       bottom "); D_printn(new.bottom);
	D_prints("        right "); D_printn(new.right);	*/
	ClipRect(&new);
	}

PopClip(pold)
	RgnHandle	*pold;
	{
	SetClip(*pold);
	DisposHandle((Handle)*pold);
	}

RectOfWin(theWin, pRect)
	WindowPtr	theWin;
	Rect		*pRect;
	{
	*pRect = theWin->portRect; 
	OffsetRect(pRect,-pRect->left, -pRect->top);
	}

SetDottedXorPen(pOldstate)		/* set an XOR, dotted pen for shadow figures */
	PenState	*pOldstate;		/* saves previous state into dummy, assumed solid */
	{
	PenState	newPenState;
	int 		i;

	GetPenState(pOldstate);
	newPenState.pnMode = patXor;
	for(i=0; i<8; ++i)	newPenState.pnPat[i] = black[i]; /* gray[i];	*/
/* Forget the grey for now - it looks BAD. Use black */
	newPenState.pnSize = pOldstate->pnSize;
	newPenState.pnLoc = pOldstate->pnLoc;
	SetPenState(&newPenState);
	}

RestoreSolidCopyPen(pOldstate)	/* restore pen state saved by previous SetDottedXor */
	PenState	*pOldstate;		/* presumed solid & copy */
	{
	SetPenState(pOldstate);
	}

WhereOfEvent(theEvent, pwhere)	/* return mouse down co-os of an event */
	EventRecord	*theEvent;
	Point	*pwhere;
	{
	*pwhere = theEvent->where;
	}

WhereOfMotionEvent(theEvent, pwhere)	/* not meaningful in mac environment? */
	EventRecord	*theEvent;
	Point	*pwhere;
	{
	*pwhere = theEvent->where;
	}

int ButtonOfEvent(theEvent)	/* return the button # of an event */
    EventRecord	*theEvent;
    {
    if(theEvent->modifiers & cmdKey)
	return(2);			/* Cmd-clik is middle button */
    else if(theEvent->modifiers & shiftKey)
	return(3);			/* shf-clk is right button */
    return(1);				/* else left button */
    }

InvalWinRect(theWindow)
	WindowPtr	theWindow;
	{
	InvalRect(&theWindow->portRect);
	}

DrawLines(pts, npts)			/* connected set of linesegs */
    Point *pts;
    int   npts;
    {
/*    XDrawLines(disp,thisWin,gc,(XPoint *)pts, npts, CoordModeOrigin); */
    if(npts)
	{
	MoveTo(pts->h, pts->v);
	while(--npts)
	    {
	    ++pts;
	    LineTo(pts->h,pts->v);
	    }
	}
    }

/* pseudo gray-scale support for b&w mac */
/* just 2 tone now */
int grays = 5;
enum { __WHITE, __LTGRAY, __GRAY, __DKGRAY, __BLACK };
unsigned long colrs[5] = { __BLACK, __DKGRAY, __GRAY, __LTGRAY, __WHITE };

ColorRect(prec, color)
	Rect *prec;
    unsigned long color;
    {
    switch(color)
    	{
    case __WHITE:		FillRect(prec,white);	break;
    case __LTGRAY:		FillRect(prec,ltGray);	break;
    case __GRAY:		FillRect(prec,gray);	break;
    case __DKGRAY:		FillRect(prec,dkGray);	break;
    default:			FillRect(prec,black);	break;
    	}	
    }

SetBlack()
    {
    }

SetRed()		/* don't know how! */
    {
    }

SetColour(colourIndex)
    int colourIndex;	/* one of RED, GREEN etc defined in DSPBench.h */
	{
	}

FlushDisplay()		/* only meaningful for X */
    {
    }

int
myTextWidth(s /* char *s */)	/* returns pixel width of rendered string */
    char *s;
    {
    return(TextWidth(s, 0, strlen(s)));
    }

int LineHeight()
    {
    FontInfo theInfo;

    GetFontInfo(&theInfo);
    return(theInfo.ascent + theInfo.descent);
    }

/* DrawMarkPoints(pts, npts)		/* set of points as little markers */
/*    Point *pts;
/*    int   npts;
/*    {
/*    Rect rec;
/*
/*    while(npts--)
/*	{
/*	rec.left = pts->h + MRKRLEFT;
/*	rec.top  = pts->v + MRKRTOP;
/*	rec.right= pts->h + MRKRRIGHT;
/*	rec.bottom = pts->v + MRKRBOTTOM;
/*	FrameRect(&rec);
/*	++pts;
/*	}
/*    }		*/

/* unix function not provided as such */
/* char *rindex(char *s, char c)
/*	{
/*	char *t;
/*	
/*	t = s;
/*	while(*t++)		/* seek end of string */
/*		;
/*	while(--t >= s && *t != c)
/*		;			/* search back to start for match */
/*	if(*t != c)
/*		t = NULL;	/* if not found, return NULL */
/*	return t;
/*	}	/*	*/

int ScanMouseEvent()
    {
	return(0);	/* ?? */
    }

int WaitMouseEvent()
    {
    int rc;
    
	while( (rc=ScanMouseEvent()) == 0)
		;
	return rc;
    }

#else	/* UNIX/X here on ------------------------------------ */

#include <stdio.h>	/* for D_prints */
#include <strings.h>
#include "DSPbench.h"
#include <X11/Xatom.h>

#define  LTHIK 0	/* thinnest lines */
extern Display *disp;
extern int     scrnNum;
extern GC      gc;
extern Cursor  arrow;

static Window  thisWin;

Handle NewHandle(size)	/* sets up a pointer to a block of size bytes */
    long    size;
    {
    Handle  ptr;

    size += sizeof(Handle);
    ptr = (Handle)Mymalloc(size, 1L, "NewHandle");
    *ptr = ((Byte *)ptr) + sizeof(Handle);
    return(ptr);
    }

DisposHandle(old)
    Handle old;
    {
    free(old);
    }

D_prints(s)
    char *s;
    {
    printf(s);
/*    printf("\n");	*/
    }

D_printn(n)
    int n;
    {
    printf("%d\n",n);
    }

HLock(han)
    Handle han;
    {
    }

HUnlock(han)
    Handle han;
    {
    }

TextFont(f)
    int	f;
    {
    }

TextSize(s)
    int s;
    {
    }

int PtInRect(pt, prect)
    Point   pt;
    Rect    *prect;
    {	/* the nasty philosophical problem remains .. */
    if( (pt.h >= prect->left) && (pt.h <= prect->right)
       && (pt.v >= prect->top) && (pt.v <= prect->bottom))
	return(1);
    else
	return(0);
    }

WhereOfEvent(theEv,pPt)
    EventRecord *theEv;
    Point	*pPt;
    {
    XEvent	*xev;

    xev = theEv;
    pPt->h = xev->xbutton.x;
    pPt->v = xev->xbutton.y;
    }

int ButtonOfEvent(theEvent)	/* return the button # of an event */
    XButtonEvent	*theEvent;
    {
    return theEvent->button;
    }

WhereOfMotionEvent(theEv,pPt)
    EventRecord *theEv;
    Point	*pPt;
    {
    XEvent	*xev;

    xev = theEv;
    pPt->h = xev->xmotion.x;
    pPt->v = xev->xmotion.y;
    }

InvalWinRect(ptheWin)
    WindowPtr   *ptheWin;
    {
    XWindowAttributes xwats;
    Window  win;

/*    win = *ptheWin;
    printf("IWR: passed %lx \n",(long)win);
    XGetWindowAttributes(disp,win,&xwats);
    XClearArea(disp, win, 0,0,xwats.width,xwats.height, 0);
    /* 1 implies generate an expose event as well as clearing */
    }

SetPort(theWin)
    WindowPtr	theWin;
    {
    thisWin = theWin;
    }

RectOfWin(theWin,prect)
    WindowPtr	theWin;
    Rect	*prect;
    {
    Window	win;
    XWindowAttributes xwats;

    win = theWin;
    XGetWindowAttributes(disp,win,&xwats);
    prect->left = 0;	prect->top = 0;
    prect->right = prect->left + xwats.width;
    prect->bottom = prect->top + xwats.height;
    }

SetDottedXorPen(pdummy)
    PenState  *pdummy;	/* uneeded context for restore */
    {
    char    dashList[1];

    XSetState(disp, gc, XBlackPixel(disp,scrnNum)^XWhitePixel(disp,scrnNum),
	      XWhitePixel(disp,scrnNum),GXxor,-1L);
/*   XSetLineAttributes(disp, gc, LTHIK, LineOnOffDash, CapNotLast, JoinMiter);
    dashList[0] = '\001';
    XSetDashes(disp, gc, 0, dashList, 1);  */
    }

SetDottedPen(pdummy)
    PenState  *pdummy;	/* uneeded context for restore */
    {
    char    dashList[1];

/*    XSetState(disp, gc, XBlackPixel(disp,scrnNum)^XWhitePixel(disp,scrnNum),
	      XWhitePixel(disp,scrnNum),GXxor,-1L);  */
    XSetLineAttributes(disp, gc, LTHIK, LineOnOffDash, CapNotLast, JoinMiter);
    dashList[0] = '\001';
    XSetDashes(disp, gc, 0, dashList, 1);
    }

extern Pixmap ltGrayPM, grayPM;

SetStipplePen(pdummy)
    PenState  *pdummy;	/* uneeded context for restore */
    {
    char    dashList[1];

    XSetTile(disp, gc, grayPM); 
    XSetFillStyle(disp,gc,FillTiled);
    }

RestoreSolidCopyPen(pdummy)
    PenState *pdummy;
    {
    XSetState(disp, gc, XBlackPixel(disp,scrnNum),XWhitePixel(disp,scrnNum),
	      GXcopy,-1L);
    XSetLineAttributes(disp, gc, LTHIK, LineSolid, CapButt, JoinMiter);
    XSetFillStyle(disp,gc,FillSolid);
    }

ClipRect(prect)
    Rect *prect;
    {
    Rect new;
    XRectangle rects[1];
    short t;

    new = *prect;
    if(new.top>new.bottom) { t=new.top; new.top=new.bottom; new.bottom=t; }
    if(new.left>new.right) { t=new.left; new.left=new.right; new.right=t; }
    rects[0].x = new.left; rects[0].y = new.top;
    rects[0].width = new.right-new.left; 
    rects[0].height = new.bottom-new.top;
    XSetClipRectangles(disp, gc, 0, 0, rects, 1, Unsorted);
    }

PushClip(pdummy, new)
    RgnHandle *pdummy;
    Rect      new;
    {
    ClipRect(&new);
    }

PopClip(pdummy)
    RgnHandle *pdummy;
    {
    XSetClipMask(disp, gc, None);
    }

static  XPoint last_pt;

MoveTo(x,y)
    short x,y;
    {
    last_pt.x = x;
    last_pt.y = y;
    }

LineTo(x,y)
    short x,y;
    {
/*    fprintf(stderr,"d%lx w%lx g%lx x%dy%d-x%dy%d\n",
	    disp, thisWin, gc, last_pt.x, last_pt.y, x, y);  */
    XDrawLine(disp, thisWin, gc, last_pt.x, last_pt.y, x, y);
    MoveTo(x,y);
    }

InsetRect(prect,xi,yi)
    Rect *prect;
    short xi,yi;
    {
    prect->top += yi;
    prect->bottom -= yi;
    prect->left += xi;
    prect->right -= xi;
    }

OffsetRect(prect,xo,yo)
    Rect *prect;
    short xo,yo;
    {
    prect->top += yo;
    prect->bottom += yo;
    prect->left += xo;
    prect->right += xo;
    }

PlotIcon(prect, iHan)
    Rect *prect;
    Icon iHan;
    {
    XCopyArea(disp, iHan, thisWin, gc, 0, 0, ICONWIDTH, ICONHEIGHT,
	      prect->left, prect->top);    /* ? */
    }	

CtoPstr(s)
    char *s;
    {
    }

PtoCstr(s)
    char *s;
    {
    }

EraseRect(prec)
    Rect *prec;
    {
    int  x,y,w,h;

    x = prec->left;		y = prec->top;
    w = prec->right-x-1;	h = prec->bottom-y-1;
    XClearArea(disp, thisWin, x,y,w,h, 0);  /* 0 => no Expose events */
    }

FrameRect(prec)
    Rect *prec;
    {
    int  x,y,w,h;

    x = prec->left;		y = prec->top;
    w = prec->right-x-1;	h = prec->bottom-y-1;
    XDrawRectangle(disp, thisWin, gc, x,y,w,h);
    }

FillRect(prec,pat)
    Rect *prec;
    int  pat;
    {
    if(pat == (int)black)
	PaintRect(prec);
    else
	{
	int  x,y,w,h;

	if(pat == (int)ltGray)
	    {
	    XSetTile(disp, gc, ltGrayPM); 
	    XSetFillStyle(disp,gc,FillTiled);
	    }

	x = prec->left;		y = prec->top;
	w = prec->right-x;	h = prec->bottom-y;
	XFillRectangle(disp, thisWin, gc, x,y,w,h);
	XSetFillStyle(disp,gc,FillSolid);
	}
    }

PaintRect(prec)
    Rect *prec;
    {
    int  x,y,w,h;

    x = prec->left;	y = prec->top;
    w = prec->right-x;	h = prec->bottom-y;
    XFillRectangle(disp, thisWin, gc, x,y,w,h);
    }

ColorRect(prec, color)
	Rect *prec;
	unsigned long color;
	{
	XSetForeground(disp, gc, color);
	PaintRect(prec);
	}

static XColor dummy;
static XColor blackCol = {0,0,0,0,0,0}, whiteCol = {0,0,0,0,0,0};
static XColor redCol = {0,0,0,0,0,0}, greenCol = {0,0,0,0,0,0};
static XColor blueCol = {0,0,0,0,0,0}, magentaCol = {0,0,0,0,0,0};
static XColor yellowCol = {0,0,0,0,0,0}, cyanCol = {0,0,0,0,0,0};
/* order must match #define BLACK etc in dspBench.h */
static XColor *colours[NUM_COLOURS]; 

SetupColours()
    {
    if(redCol.pixel == 0)  {
#ifdef PALE_COLORS
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum),"palevioletred1",
			 &redCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "mintcream",
			 &greenCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "lightskyblue",
			 &blueCol, &dummy);
#else /* !PALE_COLORS */
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "red",
			 &redCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "green3",
			 &greenCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "royalblue1",
			 &blueCol, &dummy);
#endif /* PALE_COLORS */
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "magenta",
			 &magentaCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "cyan",
			 &cyanCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "yellow",
			 &yellowCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "black",
			 &blackCol, &dummy);
	XAllocNamedColor(disp, DefaultColormap(disp, scrnNum), "white",
			 &whiteCol, &dummy);
	colours[BLACK] = &blackCol;
	colours[WHITE] = &whiteCol;
	colours[RED]   = &redCol;
	colours[GREEN] = &greenCol;
	colours[BLUE]  = &blueCol;
	colours[YELLOW]= &yellowCol;
	colours[MAGENTA]= &magentaCol;
	colours[CYAN]  = &cyanCol;
	}
    }

SetRed()
    {
    if(redCol.pixel == 0)
	SetupColours();
    XSetForeground(disp, gc, redCol.pixel);
    }

SetCyan()
    {
    if(redCol.pixel == 0)
	SetupColours();
    XSetForeground(disp, gc, cyanCol.pixel);
    }

SetBlue()
    {
    if(redCol.pixel == 0)
	SetupColours();
    XSetForeground(disp, gc, blueCol.pixel);
    }

SetGreen()
    {
    if(greenCol.pixel == 0)
	SetupColours();
    XSetForeground(disp, gc, greenCol.pixel);
    }

SetColour(colourIndex)
    int colourIndex;	/* one of RED, GREEN etc defined in DSPBench.h */
    {
    if(colourIndex < 0 || colourIndex >= NUM_COLOURS)
	{  fprintf(stderr, "SetColour: %d out of range 0..%d\n",
		   colourIndex, NUM_COLOURS);	abort();	}
    if(blueCol.pixel == 0)
	SetupColours();
    XSetForeground(disp, gc, colours[colourIndex]->pixel);
    }

SetBlack()
    {
    XSetForeground(disp, gc, XBlackPixel(disp,scrnNum));
    }

SetWhite()
    {
    XSetForeground(disp, gc, XWhitePixel(disp,scrnNum));
    }

int ScanMouseEvent()
    {
    XEvent ev;
    if(XCheckWindowEvent(disp, thisWin, ButtonPressMask| KeyPressMask, 
			      &ev))
	return(ev.xbutton.button);
    else
	return(0);
    }

int WaitMouseEvent()
    {
    XEvent ev;
    XWindowEvent(disp, thisWin, ButtonPressMask, &ev);
	return(ev.xbutton.button);
    }

int StillDown()
    {
    return(1);		/* can't really do this one.. */
    }

static int mouse_x, mouse_y;

GetMouse(pPt)
    Point *pPt;
    {
    pPt->h = mouse_x;
    pPt->v = mouse_y;
    }

WaitMouseUp()
    {
    return(!NextMousyEvent());
    }

int NextMousyEvent()
    {
    XEvent theEv;
    int	   done = 0;
    
    XWindowEvent(disp, thisWin, ButtonReleaseMask|ButtonMotionMask, &theEv);
    switch(theEv.type)
	{
    case ButtonRelease:
	done = 1;
	break;
    case MotionNotify:
	mouse_x = theEv.xmotion.x;
	mouse_y = theEv.xmotion.y;
	break;
    default:
	break;
	}
    return(done);
    }

static reverse(s)	/* reverse a string in place, from K&R p59 */
    char *s;
    {
    int	c,i,j;

    for(i=0, j=strlen(s)-1; i<j; i++, j--)
	{
	c = s[i];
	s[i] = s[j];
	s[j] = c;
	}
    }

NumToString(n,s)	/* after itoa(), K&R p60 */
    long    n;
    char    *s;
    {
    int i, sign;

    if((sign = n)<0)
	n = -n;
    i = 0;
    do  {
	s[i++] = (n%10L) +'0';
	} while( (n /= 10L) >0);
    if(sign < 0)
	s[i++] = '-';
    s[i] = '\0';
    reverse(s);
    }

SetCursor(pCurs /* Cursor *pCurs */)
    Cursor *pCurs;
    {
    if(pCurs == &arrow)
	XUndefineCursor(disp, thisWin);
    else
	XDefineCursor(disp, thisWin, *pCurs); 
    XSync(disp, 0);
    }

/* X-window implementation of support routines for db.menu.c */

static XFontStruct 	*xbfsp;
static Font		xbfont;

static int XInited = 0;
void InitX()			/* some of.. */
    {
    char *fontnm;
    extern char *fontname;

    if(XInited)
	return;
    else
	{
/*	fontname = "6x13";	*/
/*	fontname = "*-courier-bold-r-normal--24-*";	*/
	xbfsp = XLoadQueryFont(disp,fontname);
	if(xbfsp == NULL)
	    {
	    D_prints("cannot load font ");
	    D_prints(fontname);
	    D_prints("; trying 'fixed'\n");
	    xbfsp = XLoadQueryFont(disp, "fixed");
	    }
	xbfont = xbfsp->fid;
	XInited = 1;
	}
    }

int
myTextWidth(s /* char *s */)	/* returns pixel width of rendered string */
    char *s;
    {
    return(XTextWidth(xbfsp, s, strlen(s)));
    }

int LineHeight()		/* returns height of current font */
    {
    unsigned long 	ascent, descent;
    int height;

/*    XGetFontProperty(xbfsp, XA_STRIKEOUT_ASCENT, &ascent);	*/
/*    XGetFontProperty(xbfsp, XA_STRIKEOUT_DESCENT, &descent);	*/
    ascent = xbfsp->ascent;
    descent = xbfsp->descent;
    height = ascent+descent;
    return height;
    }

DrawString(s)
    char *s;
    {
    XTextItem txitem[1];

    txitem[0].chars = s;
    txitem[0].nchars = strlen(s);
    txitem[0].delta  = 1;
    txitem[0].font   = xbfont;
    XDrawText(disp, thisWin, gc, last_pt.x, last_pt.y, txitem, 1);
    }

WriteText(x,y,s /* int x, int y, char *s */)	/* text to screen - not used */
    int	x,y;
    char *s;
    {
    XTextItem txitem[1];

    txitem[0].delta = 1;
    txitem[0].font  = xbfont;
    txitem[0].chars = s;
    txitem[0].nchars = strlen(s);
    XDrawText(disp, thisWin, gc, x,y,txitem,1);
    }

static Window oldWin;		/* yuccy hack */

Window
PopNewWindow(par,x,y,w,h)	/* open new region as subwindow */
    Window par;
    int	x,y,w,h;
    {
    XSetWindowAttributes attribs;
    unsigned long        amask;
    Window   win;

    attribs.background_pixel = XWhitePixel(disp,scrnNum);
    attribs.backing_store = WhenMapped;
    attribs.event_mask    = ExposureMask ; /* | ButtonPressMask |
	                      ButtonReleaseMask | ButtonMotionMask;	*/
    attribs.save_under    = True;
    attribs.override_redirect = True;
    amask = CWBackPixel | CWBackingStore | CWEventMask | CWSaveUnder | CWOverrideRedirect;
    win = XCreateWindow(disp, par,
			x,y,w,h, 1 /*bw*/ ,
		      CopyFromParent,InputOutput,CopyFromParent,
		      amask, &attribs);
    XMapWindow(disp, win);
    oldWin = thisWin;
    thisWin = win;	/* set up global */
    WaitForExpose(win);
    return(win);
    }

WaitForExpose(w /* Window w */)
    Window w;
    {
    XEvent event;
    while( (XCheckWindowEvent(disp, w, ExposureMask, &event)));
    while(!(XCheckWindowEvent(disp, w, ExposureMask, &event)));
    }

UnpopWindow(w /* Window w */)		/* remove popup */
    Window w;
    {
    XDestroyWindow(disp,w);
    /* restore thisWin */
    thisWin = oldWin;
    }

DrawLines(pts, npts)			/* connected set of linesegs */
    Point *pts;
    int   npts;
    {
    XDrawLines(disp,thisWin,gc,(XPoint *)pts, npts, CoordModeOrigin);
    }

FlushDisplay()		/* only meaningful for X */
    {
    XFlush(disp);
    }

int ShiftIsDown()	/* check keys */
{
    Window	root, child;
    int 	rx, ry, wx, wy;
    unsigned int keys;

    XQueryPointer(disp, thisWin, &root, &child, &rx, &ry, 
		  &wx, &wy, &keys);
    return ((keys & ShiftMask)!= 0);
}
	

#endif

/* non mach specific fns - should be in grutl ? */

MarkX(prec)
    Rect *prec;
    {
    Rect rec;
     Point	*ptptr, pts[5];

    rec = *prec;
     ptptr = pts;
     ptptr->h = rec.left;
     ptptr->v = rec.top;
     ++ptptr;
     ptptr->h = rec.right;
     ptptr->v = rec.bottom;
     ++ptptr;
     ptptr->h = rec.left;
     ptptr->v = rec.bottom;
     ++ptptr;
     ptptr->h = rec.right;
     ptptr->v = rec.top;
     ++ptptr;
     ptptr->h = rec.left;
     ptptr->v = rec.top;
     ++ptptr;

     DrawLines(pts,5);
     }

DrawMarkPoints(pts, npts, marker)	/* set of points as little markers */
    Point *pts;
    int   npts;
    int   marker;		/* 0, 1 look different */
    {
    Rect rec;

    while(npts--)
	{
	rec.left = pts->h + MRKRLEFT;
	rec.top  = pts->v + MRKRTOP;
	rec.right= pts->h + MRKRRIGHT;
	rec.bottom = pts->v + MRKRBOTTOM;
	if(marker == 1)
	    FrameRect(&rec);
	else
	    MarkX(&rec);
	++pts;
	}
    }

/************ PIXMAP section ********* 1993jan12 dpwe ******/

#ifndef THINK_C		/* don't know what to do for pixmaps on mac yet */

PIXMAP pxmNew(int w, int h)
{	/* create a new pixmap */
    Pixmap     	pm;
    int		depth;

    depth = DisplayPlanes(disp,scrnNum);
    pm = XCreatePixmap(disp, thisWin, w, h, depth);
    if(pm == NULL)  {
	fprintf(stderr, "pxmNew: couldn't get a %dx%dx%d pixmap\n",
		w, h, depth);
	abort();
    }
    return (PIXMAP)pm;
}

pxmFree(PIXMAP pxm)
{
    XFreePixmap(disp, (Pixmap)pxm);
}

pxmShow(PIXMAP pxm, Rect *r)
{	/* render pixmap at rectangle specified */
    XCopyArea(disp, pxm, thisWin, gc, 0, 0, RWIDTH(r), RHEIGHT(r), 
	      RX(r), RY(r));
}

pxmPaintRect(PIXMAP pxm, Rect *prec)
    {
    int  x,y,w,h;

    x = prec->left;	y = prec->top;
    w = prec->right-x;	h = prec->bottom-y;
    XFillRectangle(disp, pxm, gc, x,y,w,h);
    }

#else /* THINK_C */

PIXMAP pxmNew(int w, int h)
{	/* create a new pixmap */
    return (PIXMAP)NULL;
}

pxmFree(PIXMAP pxm)
{
}

pxmShow(PIXMAP pxm, Rect *r)
{	/* render pixmap at rectangle specified */
}

pxmPaintRect(PIXMAP pxm, Rect *prec)
    {
    }


#endif /* THINK_C */
