/***************************************************************\
*	arrayops.h						*
*  Some stuff to work on arrays					*
*  Snatched out of stripk.c					*
*  dpwe 06mar91							*
\***************************************************************/

#ifndef _ARRAYOPS_H_
#define _ARRAYOPS_H_

#include <resample.h>

/* data types */
typedef unsigned char MyByte;

#define BYTEMAX 255

typedef struct SampArray
    {
    long	rows, cols;
    SAMPL	*data;
    } SampArray;

typedef struct ByArray		/* for passing to GrayScale routines */
    {
    int 	rows, cols;
    MyByte	*data;
    } ByArray;

/* function prototypes */
#ifdef __STDC__
SampArray *NewSampA(long rows, long cols);
ByArray   *NewByteA(long rows, long cols);
void BAFree(ByArray *ba);
void SAFree(SampArray *sa);
SAMPL FindArrayMax(SampArray *sar);
void SampAToByteA(SampArray *sa_a, ByArray **pby_a, FLOATARG factor,
		  int logflag, FLOATARG dbFact, int offset, int min, int max);
void PickColPeaks(SampArray *ar);
void PickRowPeaks(SampArray *ar);
void DifferenceArray(SampArray *ar);
void DifferenceArrayC(SampArray *ar);
void DilateArray(SampArray **par, long p, long q);
void DilateVector(SAMPL *src, SAMPL *dst, long dil, long len);
void DilArray(SampArray **par, long p, long q);
void DilVector(SAMPL *src, SAMPL *dst, long len, long dil, long rows);
void ResampArray(SampArray **par, long p, long q);
void oldTranspose(SampArray *ar);
void Transpose(SampArray *ar);
void ReverseRows(SampArray *ar);
void PrintArr(SampArray *ar);

#else
SampArray *NewSampA();
ByArray   *NewByteA();
void BAFree();
void SAFree();
SAMPL FindArrayMax();
void SamplAToByteA();
void PickColPeaks();
void PickRowPeaks();
void DifferenceArray();
void DifferenceArrayC();
void DilateArray();
void DilateVector();
void DilArray();
void DilVector();
void ResampArray();
void oldTranspose();
void Transpose();
void ReverseRows();
void PrintArr();

#endif

#endif /* _ARRAYOPS_H_ */
