/***************************************************************\
*	byteswap.h		  				*
*   swap bytes e.g. for files between different machines 	*
*   dpwe 11nov91 after sndcvt 20feb91				*
\***************************************************************/

/* byte order types - machmode values */
#define INORDER 0
#define BYTEREV 1
#define WORDREV 2
#define BYWDREV 3

/* nice (untested) macros */
/* swap bytes in a word */
#define WSWAPB(w)  (((0xFF&w)<<8)|((0xFF00&w)>>8))
/* reverse the bytes in a long (BYWDREV) */
#define LSWAPB(l)  ((((0xFF000000&l)>>24)&0xFF)|((0xFF0000&l)>>8)\
                                 |((0xFF00&l)<<8)|((0xFF&l)<<24))
/* just swap the words in a long (WORDREV) */
#define LSWAPW(l)  ((((0xFFFF0000&l)>>16)&0xFFFF)|((0xFFFF&l)<<16))

/* static function prototype */
int MatchByteMode(long red, long target);
    /* return the bytemode to apply to 'red' to make 'target', or -1 */
int   HostByteMode PARG((void)); /* relative to 68000-style (MSB byte first) */
char *BytemodeName PARG((int bytemode));
short wshuffle PARG((int w, int mode));
long  lshuffle PARG((long l, int mode));
long  FloatAsLong PARG((FLOATARG f, int mode));
float FloatFromLong PARG((long l, int mode, long fixup));
void  ConvertBufferBytes PARG((char *buf, long bytes, int wordsz, int mode));
