/* fakeAF.h

   Emulate the SGI AF calls but redirect to SNDF
   hmmm... might work!
   dpwe 1992sep05
 */

#ifdef __sgi
/* #define __EXTENSIONS__ 	/* in order to get fdopen() prototype */
/* __EXTENSIONS__ appears to have been dropped in 5.1.1 - 
   _POSIX_SOURCE should work on both 4.0.5 and 5.1.1  dpwe 1993oct08 */
#define _POSIX_SOURCE 	/* in order to get fdopen() prototype */
#endif /* __sgi */

#include <stdio.h>
#include <sndf.h>

typedef struct {
    SFSTRUCT 	*snd;		
    FILE	*file;
    int 	op;		/* FKAF_READ or FKAF_WRITE */
} AFfile, *AFfilehandle;	/*!! tricky fake audiofile */

typedef SFSTRUCT *AFfilesetup;

/* from actual <audiofile.h> .. */
typedef void (*AFerrfunc)(long, const char*,...);

/***** defines *****/
#define AF_NULL_FILEHANDLE	NULL
#define AF_DEFAULT_TRACK	0
/* file format types */
#define AF_FILE_AIFF	1
#define AF_FILE_AIFFC	2
/* sample format types */
#define AF_SAMPFMT_TWOSCOMP	1
/* compression types */
#define AF_COMPRESSION_NONE	1

/***** prototypes *****/
AFfilesetup   AFnewfilesetup(void);
AFfilehandle  AFopenfile(char *path, char *mode, AFfilesetup setup);
int           AFgetchannels(AFfilehandle handle, int track);
long 	      AFgetsampcnt(AFfilehandle handle, int track);  /* NOT /chans! */
double	      AFgetrate(AFfilehandle handle, int track);
void 	      AFclosefile(AFfilehandle handle);
void	      AFfreefilesetup(AFfilesetup setup);
int 	      AFinitchannels(AFfilesetup setup, int track, int chans);
int 	      AFinitrate(AFfilesetup setup, int track, double rate);
long	      AFreadsamps(AFfilehandle handle, int track, void *buf, 
			  			  long nsamps);		/* samples, not sframes */
long 	      AFwritesamps(AFfilehandle handle, int track, void *buf, 
			   			   long nsamps);	/* samples, not sframes */
long	      AFreadframes(AFfilehandle handle, int track, void *buf, 
			  				long count);	
long 	      AFwriteframes(AFfilehandle handle, int track, void *buf, 
			   				long count);


AFerrfunc     AFseterrorhandler(AFerrfunc efunc);	/* what to do ? */

/* new for awcmp on mac */
AFfilehandle  AFopenfd(int fd, char *mode, AFfilesetup setup);
void 		  AFgetsampfmt(AFfilehandle file, long track, 
						   long *sampfmt, long *sampwidth);
void		  AFinitfilefmt(AFfilesetup setup, long fmt);
void		  AFinitinstids(AFfilesetup setup, long instids[], long ninsts);
void		  AFinitmiscids(AFfilesetup setup, long miscids[], long nmisc);
void		  AFinitmarkids(AFfilesetup setup, long trackid, 
							long markids[], long nmarks);
void		  AFinitcompression(AFfilesetup setup, long track, 
								long compression);
void		  AFinitsampfmt(AFfilesetup setup, long track,
							long sampfmt, long sampwidth);


