/***************************************************************\
*   hexdump.h													*
*	Print hex data formatted nicely (like od -h or bdump)		*
*   Header file													*
*   dpwe 1993mar19							                    *
\***************************************************************/

void hexdumpLine(FILE *stream, BYTE *data, long len, long base);
/* print out <len> bytes from <data> in hex to <stream>, numbering 
   them starting at <base>.  Every byte is printed explicitly.  */ 
void hexdumpLines(FILE *stream, BYTE *data, long len, long base);
/* as hexdumpLine(), except repeated lines (blocks of 16 bytes) are 
   condensed into a single line */
int hexdumpFile(FILE *file, long len, long base);
/* dump data from a file (using hexdumpLines()) */
