/***************************************************************\
* idrawop.h							*
* header for idrawop.c						*
* Provide graphics primitives that write an idraw file op	*
* Based on stripk		 				*
* Generalized dpwe 1992oct24					*
\***************************************************************/

#include "wndw.h"
#include <arrayops.h>

enum {	/* indexes for selecting fonts */
    IDF_HELV_SMALL,
    IDF_HELV_MEDIUM,
    IDF_HELV_BIG,
    IDF_COUR_SMALL,
    IDF_COUR_MEDIUM,
    IDF_COUR_BIG
    };

void idMap(int x, int y, int *mx, int *my);
	/* translate co-ordiantes for bounding box calcs */
void idOpen PARG((WIND *wind, char *fname, int x, int y, int w, int h));
void idClose PARG((WIND *wind));
void idLineTo PARG((WIND *wind, int x, int y));
void idPolyLine PARG((WIND *wind, int buf[][2], long cnt));
void idFrame PARG((WIND *wind, RECT *pr));
void idFill PARG((WIND *wind, RECT *pr));
void idRectRleGraymap PARG((WIND *wind, RECT *pr, ByArray *array));
void idRleGraymap PARG((WIND *wind, int x, int y, ByArray *array));
void idGraymap PARG((WIND *wind, int x, int y, ByArray *array));
void idWriteAt PARG((WIND *wind, int x, int y, char *str));

void idSetFont PARG((WIND *wind, int fontindex));
void idSetDPs PARG((WIND *wind, int ndps));
    /* specify the number of decimal places to which vertices are 
       stored in the written file.  Idraw will not read the file unless 
       this is 0 */

