/***************************************************************\
*	samplops.h						*
*  Basic sample-type operations					*
*  dpwe 28feb91							*
\***************************************************************/

#ifndef _SAMPLOPS_H_
#define _SAMPLOPS_H_

#include "dpwelib.h"	/* file ops, PARG */

#define FLOATSAMPLS  /* FLOATSAMPLS seem to be fastest !!!! */
/* alternatives are FLOATSAMPLS, SHORTSAMPLS and LONGSAMPLS */

#ifndef SHORTMAX
#define SHORTMAX	32767
#endif  /* SHORTMAX */

#define FWD	1
#define REV	0	/* for CopySampls */

#ifdef SHORTSAMPLS
typedef short SAMPL;
typedef long  LONGSAMPL;
#define SAMPLUNITY      SHORTMAX
#define SCALEDOWN(x)	((x)>>15)
#define UNITYCLIP

#else
#ifdef LONGSAMPLS	/* use longs as shorts with extra headroom */
typedef long SAMPL;
typedef long LONGSAMPL;
#define SAMPLUNITY	SHORTMAX
#define SCALEDOWN(x)	((x)>>15)
/* no UNITYCLIP */

#else   /* presumably FLOATSAMPLS */
typedef float  SAMPL;
typedef double LONGSAMPL;
#define SAMPLUNITY	1.0
#define SCALEDOWN(x)	(x)
/* no UNITYCIP */

#endif /* LONGSAMPLS */
#endif /* SHORTSAMPLS */
/* prototypes */
long WriteShortSampls PARG((SAMPL *buf, long len, FILE *outf));/* messes buf */
long ReadShortSampls  PARG((SAMPL *buf, long len, FILE *inf));
void Sampl2Short PARG((SAMPL *sb, int sinc, short *db, int dinc, long len));
void Short2Sampl PARG((short *sb, int sinc, SAMPL *db, int dinc, long len));
void Short2Float PARG((short *sb, int sinc, float *fb, int finc, long len));
long Float2Short PARG((float *sb, int sinc, short *db, int dinc, long len));
    /* returns number of clips */
void Short2Long  PARG((short *sb, int sinc, long *fb, int finc, long len));
long Long2Short  PARG((long *sb, int sinc, short *db, int dinc, long len));
    /* returns number of clips */
void CopyChars   PARG((char *sce, int sinc, char *dst, int dinc, long len, 
		       int fwdNbk));
void ClearChars  PARG((char *sptr, int  sinc, long len));
void CopyShorts  PARG((short *sce, int sinc, short *dst, int dinc, long len, 
		       int fNb));
void ClearShorts PARG((short *sptr, int sinc, long len));
void CopyFloats  PARG((float *sce, int sinc, float *dst, int dinc, long len,
		       int fNb));
void ClearFloats PARG((float *sptr, int sinc, long len));
void CopySampls  PARG((SAMPL *sce, int sinc, SAMPL *dst, int dinc, long len,
		       int fNb));
void ClearSampls PARG((SAMPL *sptr, int sinc, long len));
void ScaleSampls PARG((SAMPL *sptr, int sinc, SAMPL *dptr, int dinc, long len, 
		       LONGSAMPL factor));
void OverlaySampls PARG((SAMPL *sptr, int sinc, SAMPL *dptr, int dinc, 
			long len, LONGSAMPL factor));

#endif /* !_SAMPLOPS_H_ */
