/***********************************************************************\
*    selwndw.h								*
*    Use <wndw.c> interface to manage a menu of selections		*
*    For track objects in dspB initially				*
*    header function							*
*    dpwe 1993apr21							*
\***********************************************************************/

/* 
 * Changes:
 * 1994feb09 dpwe	added <btn> field to selCbFn.
 * 
 */

#include <dpwelib.h>
#include <wndw.h>	/* definition of primitives we will use */

#ifndef __SELPNL_STR_DEFD__
typedef void *SELPNL_STR;	/* structure for whole panel */
#define __SELPNL_STR_DEFD__
#endif /* !__SELPNL_STR_DEFD__ */

enum {	/* values passed in <state> on callback */
    SPNL_ARM	= 1,	/* mouse DOWN on the item (so hilit) */
    SPNL_DISARM, 
    SPNL_ACTIVATE
    };

typedef struct _sel_entry {	/* selection list entry */
    SELPNL_STR		*spnl;	/* allow cb function to find these args .. */
    char 		*name;		/* title to display */
    int 	(*cbFn)(void *data, int state, struct _sel_entry *se, int btn);
/*    selCbFn		cbFn;		/* function to call on select */
    void		*cbData;	/* argument to callback fn */
    int 		index;		/* where it appears in list */
} SELENTRY;

typedef int (*selCbFn)(void *data, int state, struct _sel_entry *se, int btn);
/* on selection, an entry calls back its function as above */

SELPNL_STR *spnlNew(char *title);
    /* initialize new selpanel window, empty at first */
void spnlFree(SELPNL_STR *spnl);
    /* destroy a selpanel */
char *spnlGetTitle(SELPNL_STR *spnl);
    /* return the name given to this spnl on initialization */
void spnlSetTitle(SELPNL_STR *spnl, char *title);
    /* change the name of this selpnl */
int spnlUnhide(SELPNL_STR *spnl);
    /* call to allow clients to unhide window if it has been hidden */
void spnlDraw(SELPNL_STR *spnl, RECT *exR);
    /* redraw the panel e.g. after an expose.  
       No tricks; always draw whole thing for now */
int spnlEvent(XEvent *event, SELPNL_STR *spnl);	/* args rvsd as gen.ev.fn */
    /* somebody wanted to show us this event.  If take it, return 1
       else 0 (i.e. give to someone else) */
char *stralloc(char *str);
    /* allocate a new string a copy of existing */
SELENTRY *spnlAddEntry(SELPNL_STR *spnl, char *name, 
		       selCbFn cbFn, void *cbData);
    /* add an entry to the list */
int spnlRmvEntry(SELPNL_STR *spnl, SELENTRY *se);
    /* remove entry indicated by <se> (previously returned by spnlAddE)
       from <spnl>; return 1 on success, 0 if couldn't find it */
int spnlGetNEntries(SELPNL_STR *spnl);
    /* find the number of entries in the SELPNL_STR **/
SELENTRY *spnlGetNth(SELPNL_STR *spnl, int ix);
    /* get the SELENTRY str for an entry in the panel, referred 
	   by its index <ix> = 0.. spnlGetNEntries(spnl) - 1 */
SELENTRY *spnlGetSelected(SELPNL_STR *spnl);
    /* return the currently hilit item, or NULL if none */
int spnlSelect(SELPNL_STR *spnl, SELENTRY *se);
	/* force selection to be specified entry;
           return 1 if found, 0 o/w (in which case, no selection, 
				     so spnlSelect(spnl, NULL) unselects) */
int spnlReset(SELPNL_STR *spnl);
    /* remove all entries from a SELPN */
void spnlSetHackFn(SELPNL_STR *spnl, char *name, 
		   void (*hackFn1)(), void *data1,
		   void (*hackFn2)(), void *data2,
		   void (*hackFn3)(), void *data3);
    /* add functions for 3 mouse buttons on 3rd panel button */

