/*
 * sndtst.c
 * test the snd.c routines
 * dpwe 1994may02
 */

#include "dpwelib.h"
#include "snd.h"
#include "window.h"

char *programName;

main(int argc, char **argv)
{
    char *inPath, *outPath = NULL;
    SOUND *inSnd, *outSnd = NULL;
    float t, *buf;
    long todo, remain, frames, bufsize;
    WINDAT *disp;
    int i, wait;

    programName = argv[0];
    if(argc < 2)  {
	fprintf(stderr, "usage: %s insound [outsound]\n", programName);
	exit(1);
    }	
    inPath = argv[1];
    if(argc > 2)  {
	outPath = argv[2];
    }
    if( (inSnd = sndOpen(NULL, inPath, "r")) == NULL)  {
	fprintf(stderr, "%s: could not open '%s' as sound\n", 
		programName, inPath);
	exit(1);
    }
    if(outPath)  {
	outSnd = sndNew(inSnd);
	sndSetChans(outSnd, 2);
	sndSetUchans(outSnd, 2);
	if( (outSnd = sndOpen(outSnd, outPath, "w")) == NULL)  {
	    fprintf(stderr, "%s: error creating '%s' as output\n", 
		    programName, outPath);
	    exit(1);
	}
    }
    remain = sndGetFrames(inSnd);
    bufsize = 1024;
    sndSetUchans(inSnd, 2);
    buf = TMMALLOC(float, bufsize * sndGetUchans(inSnd), "sndtst");
    disp = NewWin(programName, wait=0);
    while(remain)  {
	todo = MIN(remain, bufsize);
	frames = sndReadFrames(inSnd, buf, todo);
	if(disp)  {
	    DoDisp(disp, buf, 2*frames);
	}
	for(i=0; i<frames; ++i)  {
	    t = buf[2*i]; buf[2*i] = buf[2*i+1]; buf[2*i+1] = t;
	}
	if(outSnd)  {
	    sndWriteFrames(outSnd, buf, frames);
	}
	remain -= frames;
    }
    sndClose(inSnd);
    if(outSnd)	sndClose(outSnd);
    ExitGraph();
}
