/*******************************************************************\
*   testsndf.c							    *
*   Test code for new sound file interface routines		    *
*   15aug90 dpwe						    *
\*******************************************************************/

#include <stdio.h>
#ifdef THINK_C
#include <stdlib.h>
#include ":::lib:T_C_main.h"
#include ":::lib:sndf.h"
/* #include ":::lib:NeXTsnd.h"	*/
#else
#include "../../lib/sndf.h"
#endif

/* globals */
char *programName;
/* SNDError soundError; */
int sfErr;

main(argc, argv)
    int argc;
    char **argv;
    {
/*  SNDSoundStruct  *inputSound;    */
    SFSTRUCT	    *inputSound,*outputSound;
    long    dataBsize, headerBsize;
    int     format;
    float   srate;
    int     chans;
    int     infoBsize;
    long    words,num,i;
    int     dummy;
    short   *scePtr, *dstPtr;
    int     c;
    char    *d,*s;
    FILE    *file;
    short   *p1,*p2;

    programName = argv[0];

    if(argc < 3)
	{
	fprintf(stderr,"Usage: %s <inputSound> <outputSound>\n",programName);
	exit(1);
	}

    /* Read sound file */
    if (sfErr = SFRead(argv[1], &inputSound))
	{
	printf("%s: sound error: %s on %s\n", programName,
		    SFErrMsg(sfErr), argv[1]);
	exit(1);
	}

    dataBsize = inputSound->dataBsize;
    headerBsize = inputSound->headBsize;
    inputSound->dataBsize = 0;	
/*    format = (inputSound->format == SFMT_SHORT)? SFMT_SHORT : SFMT_FLOAT; */
    format = (inputSound->format == SFMT_SHORT)? SFMT_SHORT : SFMT_FLOAT;
    srate  = (float)inputSound->samplingRate;
    chans  = inputSound->channels;
    infoBsize = SFInfoSize(inputSound);

    printf("data size %ld, header size %ld, info size %ld\n",
	   dataBsize, headerBsize, infoBsize);
    printf("format %d, channels %d, samp rate %8.2f\n",
	   format, chans, srate);

/*    SFAlloc(&outputSound, dataBsize, format, srate, chans, infoBsize);

    p1 = (short *)&(inputSound->info[0]);
    p2 = (short *)&(outputSound->info[0]);
    words = infoBsize/sizeof(short);
    while(words--)
	*p2++ = *p1++;		/* copy info area */

/*    p1 = (short *)SFDataLoc(inputSound);
    p2 = (short *)SFDataLoc(outputSound);
    printf("outsnd %lx data %lx\n",outputSound,p2);
    words = dataBsize/sizeof(short);
    while(words--)
	*p2++ = ~(*p1++);	/* copy & invert data */
/*    SFWrite(argv[2], outputSound);
 */
    if((file = SFOpenWrHdr(argv[2],inputSound)) == NULL)
	{
	printf("%s: SF error: couldn't open %s\n", programName,
		    argv[2]);
	exit(1);
	}
/*    PtoCstr(inputSound->info);
    printf("info: %s\n",inputSound->info);
 */

    words = dataBsize / sizeof(short);

    num = fwrite((void *)SFDataLoc(inputSound),(size_t)sizeof(short), (size_t)words, file);
    if(num<words)
	{
	printf("Little written %ld out of %ld\n", num, words);
	exit(1);
	}

    SFCloseWrHdr(file,NULL);

    }
