/*******************************************************************\
*   testsndf.c							    *
*   Test code for new sound file interface routines		    *
*   15aug90 dpwe						    *
\*******************************************************************/

#include <stdio.h>

#ifdef THINK_C		/* for Macintosh build */
#include <stdlib.h>
#include <tc_main.h>
#include <sndf.h>
char sfdir_path[] = "People's Files:dpwe:sound";
#else
#include <sndf.h>
#endif

/* globals */
char *programName;
int  sfErr;

main(argc, argv)
    int argc;
    char **argv;
    {
    SFSTRUCT	    *inputSound,*outputSound;
    long    dataBsize, headerBsize;
    int     format;
    float   srate;
    int     chans;
    int     infoBsize;
    long    words,num,i;
    int     dummy;
    short   *scePtr, *dstPtr;
    int     c;
    char    *d,*s;
    FILE    *file;

    programName = argv[0];

    if(argc < 3)
	{
	fprintf(stderr,"Usage: %s <inputSound> <outputSound>\n",programName);
	exit(1);
	}

    /* Read sound file */
    if (sfErr = SFRead(argv[1], &inputSound))
	{
	printf("%s: sound error: %s on %s\n", programName,
		    SFErrMsg(sfErr), argv[1]);
	exit(1);
	}

    dataBsize   = inputSound->dataBsize;
    headerBsize = inputSound->headBsize;
    format      = inputSound->format;
    srate       = inputSound->samplingRate;
    chans       = inputSound->channels;
    infoBsize   = SFInfoSize(inputSound);

    printf("data size %ld, header size %ld, info size %ld\n",
	   dataBsize, headerBsize, infoBsize);
    printf("format %d, channels %d, samp rate %8.2f\n",
	   format, chans, srate);

	PrintSNDFinfo(inputSound, argv[1], "type", stdout);

    if(sfErr = SFAlloc(&outputSound, dataBsize, format, 
    				   srate, chans, infoBsize))
   		SFDie(sfErr, NULL);
    printf("outsnd %lx\n",outputSound);

    s = &(inputSound->info[0]);
    d = &(outputSound->info[0]);
    i = infoBsize;
    while(i--)
	*d++ = *s++;		/* copy info area */

    scePtr = (short *)SFDataLoc(inputSound);
    dstPtr = (short *)SFDataLoc(outputSound);

    printf("data %lx\n",dstPtr);
    words = dataBsize/sizeof(short);
    while(words--)
	*dstPtr++ = ~(*scePtr++);	/* copy & invert data */

    if(sfErr = SFWrite(argv[2], outputSound))
       {
       fprintf(stderr,"%s: sound error: %s on %s\n",
	       programName, SFErrMsg(sfErr), argv[2]);
       exit(1);
       }

    }
