/***************************************************************\
*	twindow.h						*
*  header file for time window operations files			*
*  dpwe 06nov91							*
\***************************************************************/

/********   constants    ********/
typedef enum {		/* flag which window we want */
    TT_NONE,		/* not a window */
    TT_ZERO,		/* all zero ! */
    TT_HAMM,		/* hamming : .5 (1+cos(x)) */
    TT_HANN,		/* hanning : .46 - .54 cos(x) */
    TT_FRXP,		/* forward roexp() */
    TT_RRXP,		/* reverse roexp() */
    TT_OTHR		/* some other type */
    } TWINTYPE;

/********   define type   ********/
typedef struct twindow
    {
    float	*kern;		/* array of window coefficients */
    long	size;		/* floats in block pointed by kern */
    TWINTYPE 	type;		/* some description */
    } TWINDOW;

/********   fn protos    ********/
void	FreeTwindow PARG((TWINDOW *twdw));
void 	FillWindowBuffer PARG((float *buf, long size, FLOATARG fsize, 
	                           FLOATARG gain, TWINTYPE type));
TWINDOW	*NewTwindow PARG((long size, FLOATARG fsize, FLOATARG gain, 
			  TWINTYPE type));
void	ApplyTwindow PARG((TWINDOW *twdw, float *in, long insize, 
			   float *out, long outsize));
