/***************************************************************\
*	window.c						*
*	Machine-independent almost useless timegraph output	*
*	02dec90 dpwe						*
\***************************************************************/

#include <stdio.h>		/* for printf in die() */
#ifdef THINK_C
/* #define __STDC__ */ /* predefined in THINKC5 */
#include <stdlib.h>
#else
#ifdef NeXT
#include <stdlib.h>
#else
#include <malloc.h>
#endif
#endif
#include <math.h>
#include <window.h>

static int disps = 0;

/* WINDAT *SetDisp() */
WINDAT *NewWin(name, wait)
    char *name;
    int  wait;	/* 1=> wait after each draw */
    {
    WINDAT *wdptr;

    wdptr = NULL;
    if(Graphable())
	{
	disps = 1;
	if(wdptr == NULL)
	    {
	    wdptr = (WINDAT *)malloc(sizeof(WINDAT));
	    wdptr->windid = 0L;
	    }
	wdptr->waitflg = wait;	/* wait-for-clik-after-draw */
	wdptr->polarity = (short)NOPOL;
	wdptr->max      = 0.0;
	wdptr->min      = 0.0;
	wdptr->absmax   = 0.0;
	wdptr->oabsmax  = 0.0;
	wdptr->danflag  = 0;	/* central Y axis */
	if(!wdptr->windid)
	    MakeGraph(wdptr,name);
	}
    return(wdptr);
    }

void DoDisp(wdptr,data,len)
    WINDAT *wdptr;
    float *data;
    int   len;
    {
    register float *fp, *fplim;
    float	max,min,absmax,fval;
    int 	pol;

    if(wdptr == NULL || !disps)		return;
    fp    = data;
    fplim = fp + len;
    for(max = *fp++, min = max; fp < fplim; )	/* scan for min & max */
	{
	if( (fval = *fp++) > max)	max = fval;
	else if( fval < min )		min = fval;
	}
    absmax = (-min > max)? (-min):max;
    wdptr->min = min;
    wdptr->max = max;
    wdptr->absmax = absmax;
    if(absmax > wdptr->oabsmax)
	wdptr->oabsmax = absmax;
    pol = wdptr->polarity;
    if(pol == (short)NOPOL)
	{
	if(max > 0 && min < 0)		pol = (short)BIPOL;
	else if (max <= 0 && min < 0)	pol = (short)NEGPOL;
	else				pol = (short)POSPOL;
	}
    else if(pol == (short)POSPOL && min < 0) 	pol = (short)BIPOL;
    else if(pol == (short)NEGPOL && max > 0)	pol = (short)BIPOL;
    wdptr->polarity = pol;

    wdptr->fdata = data;
    wdptr->npts  = len;

    DrawGraph(wdptr);	
    }

void ResetMaxMin(wdptr)
    WINDAT *wdptr;
    {
    wdptr->polarity = (short)NOPOL;
    wdptr->max      = 0.0;
    wdptr->min      = 0.0;
    wdptr->absmax   = 0.0;
    wdptr->oabsmax  = 0.0;
    wdptr->danflag  = 0;	/* central Y axis */
    }

void die(s)
    char *s;
    {
    fprintf(stderr,"%s\n",s);
    exit(1);
    }

