/***********************************************************************\
* wndwbtn.c								*
* Installable buttons for wndw windows					*
* dpwe 1992oct24							*
\***********************************************************************/

/* 
 * Changes:
 * 1994feb09 dpwe	added <btn> field to btnFn.
 * 
 */

#include <dpwelib.h>
#include <wndw.h>

#ifndef __BTN_STR_DEFD__
typedef void BTN_STR;		/* opaque type */
#define __BTN_STR_DEFD__
#endif	/* __BTN_STR_DEFD__ */

enum {	/* possible values for BTN_STR.state */
    WBTN_QUIET = 0,
    WBTN_ARMED
};


/* the kind of function called back by a button */
typedef void (*btnFn)(WIND *wdw, BTN_STR *btn, void *data, int xbtn);

BTN_STR *wbtnNew(BTN_STR *next, WIND *wdw, int x, int y, int width, int height,
		 char *label, btnFn fn, void *fnData);
	/* width and height can be zero -> sizes to accommodate text */
BTN_STR *wbtnNext(BTN_STR *wbs);
        /* allow cdr'ing down the linked list */
void wbtnDraw(BTN_STR *wbs);
void wbtnGetRect(BTN_STR *wbs, RECT *pr);
    /* query the rectangle enclosing this button */
int wbtnPtIn(BTN_STR *wbs, int x, int y);
void wbtnHilite(BTN_STR *wbs, int state);
	/* set the state of the button */
void wbtnSetLabelPtr(BTN_STR *wbs, char *ptr);
	/* point the label to be printed at some other string */
int wbtnEvent(XEvent *event, BTN_STR *wbs);	/* args rvsd as gen.ev.fn */
	/* somebody wanted to show us this event.  If take it, return 1
	   else 0 (i.e. give to someone else) */

void NullBtnFn(WIND *wdw, BTN_STR *btn, void *data, int xbtn);
void HideBtnFn(WIND *wdw, BTN_STR *btn, void *data, int xbtn);
void QuitBtnFn(WIND *wdw, BTN_STR *btn, void *data, int xbtn);


