/***************************************************************\
*	exspec.h	header for exspec.c			*
*   Generate a best-estimate spectrum for the next time instant	*
*   based on the current tracks					*
*   dpwe 07oct91						*
\***************************************************************/

#include <dpwelib.h>
/* #include <llists.h> */	/* in peaks.h */
#include <vecops.h>	/* for cpxpolar */
#include "peaks.h"

void AddCpxPolar PARG((cpxpolar *cp1,cpxpolar *cp2));
void ExtrapTrack PARG((TRACK *trk, FLOATARG t0, PeakPos *peak));
void SuperposeHump PARG((PeakPos *peak, cpxpolar *spec, int bins, int octs, 
						FLOATARG topfrq, FLOATARG Q));
void PrintCpxPolar PARG((cpxpolar *cpxp, long n, char *s));
PKLIST ExtrapTrkList PARG((LIST curTrax, FLOATARG t0));
void PkListToSpec PARG((PKLIST pks, cpxpolar *spec, int bins, int octs, 
		  FLOATARG topfrq, FLOATARG Q));
PKLIST ExpectSpect PARG((LIST curTrax, FLOATARG t0, cpxpolar *spec,
			 int bins, int octs, FLOATARG topfrq, FLOATARG Q));
PKLIST oldExpectSpect PARG((LIST curTrax, FLOATARG t0, cpxpolar *spec, int bins, 
						int octs, FLOATARG topfrq, FLOATARG Q));

