/***************************************************************\
*	optpath.h		  				*
*   Header file for optpath.c - dyn.prog solution of ambig ph   *
*   dpwe 19sep91						*
\***************************************************************/

/* std libs */
#include <dpwelib.h>	/* for PARG(()) */
#include <llists.h>	/* for LIST etc */
#include "tracks.h"	/* for TRACK etc */

/* constants */

/* types */
typedef struct 
    {
    TRACK	*track;
    LIST	phases;		/* list of phase indexes : 0 or 1 */
    float	cost;		/* overall cost of this path */
    int 	costLen;	/* number of nodes this path is defined for */
    } PATH;

/* functions */

PATH *NewPath PARG((TRACK *track));
void FreePath PARG((PATH *path));
float CostOfPath PARG((PATH *path));
PATH *BuildBestPath PARG((TRACK *track));   /* find optimal phase choices */
void FixTrackPerPath PARG((PATH *path));
    /* swap phases in track so that path in <path> is always in ->phs */
void PrintPath PARG((PATH *path, char *name));
