/***************************************************************\
*	tkplay.h		  				*
*   Takes 'track' file as written by trk and uses the tracks 	*
*   to drive a bank of sinewave oscillators, superimposed into 	*
*   a single soundfile, the resynthesised sound.		*
*   1993mar03  dpwe after tksyn.c				*
\***************************************************************/

#include "tracks.h"
#include "trkheadio.h"

#ifndef FOR_MATLAB	/* don't link to soundfiling in matlab */
#include <snd.h>	/* for SOUND */

long tkSynthTrax(TKLIST trax, double samplingrate, SOUND *snd, void *audio);
    /* synth from a track list, writing to a SOUND file and/or 
       real-time audio output */
#endif /* !FOR_MATLAB */

int tkSave(TKHDSTRUCT *trkh, TKLIST trax, char *filename);
    /* write out the trax to the file so named */
TKHDSTRUCT *tkLoad(TKLIST *ptrax, char *filename);
    /* load the specified file into a trackstruct in memory, 
       *ptrax is pointed at the new trax 
       return track file descriptor struct or NULL if failed.  */
TKHDSTRUCT *tkLoadPrune(TKLIST *ptrax, char *filename, double magthresh);
    /* load the specified file into a trackstruct in memory, 
       apply our pruning and frequency fixup factors, 
       (prune out tracks with av. mag < magthresh (eg -20.0 dB))
       *ptrax is pointed at the new trax 
       return track file descriptor struct or NULL if failed.  */
long tkWriteSynth(TKLIST trax, double srate, int playq);
    /* synthesize a soundfile from the passed list of tracks
       at the specified sampling rate.
       Will try to play it too if <playq> */
int tkCmpTrxByT(NODE **pn1, NODE **pn2);
    /* tkplay's qsort comparison function for TRACK list nodes */
