/***************************************************************\
*	trkheadio.h		  				*
*   read and write track files to disk - with a little info	*
*   dpwe 08jul91						*
\***************************************************************/

#include <dpwelib.h>
#include <llists.h>		/* for LIST args in trkio.c prototypes */

#define TKHDDFLTBYTS 4
typedef struct trkstruct	/* descriptor at front of track file */
    {
    long	magic;		/* ID number */
    long 	headBsize;	/* bytes in header */
    long 	format;		/* format specifier ?? */
    long 	channels;	/* channels ?? */
    float 	samplingRate;	/* sr of original sound */
    float 	duration;	/* maximum extent of orig sound */
    char	info[TKHDDFLTBYTS];	/* extensible byte area */
    } TKHDSTRUCT;

/**** codes for structure ****/

#define TK_MAGIC	6613254		/* 0x64E906 - Dali's phone # */
#define TK_UNK_LEN	-1L
#define TKFMT_ASCII	1		/* numbers stored as ascii */
#define TKFMT_BINARY	2		/* numbers stored as floats */
#define TKFMT_NOPHS	3		/* new (1993apr) phaseless files */

/**** header io funcs (in trkheadio.c) ****/

int  TKAlloc PARG((TKHDSTRUCT **ptrkh, int format, FLOATARG srate, 
		  FLOATARG durn, int chans, int infoBsize));
void TKFree PARG((TKHDSTRUCT *trkh));
int TKReadHdr PARG((FILE *file, TKHDSTRUCT *trkh, int infoBmax));
FILE *TKOpenRdHdr PARG((char *path, TKHDSTRUCT *trkh, int infoBmax));
int TKInfoSize PARG((TKHDSTRUCT *trkh));
int TKRdXInfo PARG((FILE *file, TKHDSTRUCT *trkh, int done));
FILE *TKOpenAllocRdHdr PARG((char *path, TKHDSTRUCT **ptrkh));
void TKCloseRd PARG((FILE *file, TKHDSTRUCT *trkh));
int TKWriteHdr PARG((FILE *file, TKHDSTRUCT *trkh, int infoBmax));
FILE *TKOpenWrHdr PARG((char *path, TKHDSTRUCT *trkh));
void TKCloseWr PARG((FILE *file, TKHDSTRUCT *trkh));

/**** trk IO funcs (in trkio.c) *********/
void WriteTrax PARG((FILE *file, LIST list, char *name));
LIST ReadTrax PARG((FILE *file, char *name));
void BWriteTrax PARG((FILE *file, LIST list, char *name));
LIST BReadTrax PARG((FILE *file, char *name));
void WriteTrackFile PARG((LIST trax, FILE *file));
void ReadTrackFile PARG((LIST *ptrax, FILE *file));


