/***************************************************************\
*	trkprint.c		  				*
*   Print ascii reprn of track to terminal			*
*   Based on routines developed within dspB, for thesis		*
*   dpwe 08jul91						*
\***************************************************************/

/* #define DEBUGGRAPHS 1	/* only if .. */

/* std libs */
#include <dpwelib.h>
/* personal libs */
#ifdef DEBUGGRAPHS
#include <window.h>
#endif
#include "peaks.h"
#include "tracks.h"

/* constants */

/* static function prototype */
static void tklPrintSubs(TKLIST list, int level);
static void tkPrintNode(TKLIST node, int level);

/* static data */

/* functions */

static void tklPrintSubs(TKLIST list, int level)
{
    TKLIST	node;

    node = list;
    while(node)	{
	tkPrintNode(node, level);
	node = (TKLIST)CDR((LIST)node);
    }
}

void tkPrint(TRACK *trk, char *msg)
{
    fprintf(stderr, "Track %s\n", msg);
    PrintPeakList(trk->tktop, "PeakList:");	/* avoids zillions of nodes */
    fprintf(stderr, "bot %lx, nds %d, fav %.1f, fsd %.1f, mav %.1f msd %.1f tav %.4f\n",
	    trk->tkbot, trk->st.npts, trk->st.favg, trk->st.fsd,
	    trk->st.mavg, trk->st.msd, trk->st.tavg);
}

static void tkPrintNode(TKLIST node, int level)
{
    int 	t,l;
    PeakPos	*pk;

    if(node == NULL)	return;
    t = cartype((LIST)node);
    l = 0;
    while(l++<level)
	printf("    ");
    if(t == T_TRACK)
	tkPrint((TRACK *)car((LIST)node), "");
    else if(t == T_LIST)  {
	printf("Node(%lx):\n", node);
	tklPrintSubs((TKLIST)car((LIST)node), level+1);
    }
}

void tklPrint(TKLIST list, char *name)
{
    printf("%s\n",name);
    tklPrintSubs(list, 0);
}

